# kykyapi-client

KykyapiClient - JavaScript client for kykyapi-client
KYKY Lasi Oy - ERP API
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.0.1
- Package version: 0.0.83
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install kykyapi-client --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your kykyapi-client from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('kykyapi-client')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var KykyapiClient = require('kykyapi-client');

var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix['Authorization'] = "Token"

var api = new KykyapiClient.AttachmentsApi()

var body = new KykyapiClient.Attachment(); // {Attachment} Payload

api.createAttachment(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});


```

## Documentation for API Endpoints

All URIs are relative to *https://localhost/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*KykyapiClient.AttachmentsApi* | [**createAttachment**](docs/AttachmentsApi.md#createAttachment) | **POST** /attachments | create attachment
*KykyapiClient.AttachmentsApi* | [**findAttachment**](docs/AttachmentsApi.md#findAttachment) | **GET** /attachments/{attachmentId} | Find a attachment by id
*KykyapiClient.AttachmentsApi* | [**findAttachmentData**](docs/AttachmentsApi.md#findAttachmentData) | **GET** /attachments/{attachmentId}/data | Find a attachment data by id
*KykyapiClient.CataloguesApi* | [**createCatalogue**](docs/CataloguesApi.md#createCatalogue) | **POST** /catalogues | Create catalogue
*KykyapiClient.CataloguesApi* | [**deleteCatalogue**](docs/CataloguesApi.md#deleteCatalogue) | **DELETE** /catalogues/{catalogueId} | Delete catalogue
*KykyapiClient.CataloguesApi* | [**findCatalogue**](docs/CataloguesApi.md#findCatalogue) | **GET** /catalogues/{catalogueId} | Find catalogue
*KykyapiClient.CataloguesApi* | [**listCatalogues**](docs/CataloguesApi.md#listCatalogues) | **GET** /catalogues | List catalogues
*KykyapiClient.CataloguesApi* | [**updateCatalogue**](docs/CataloguesApi.md#updateCatalogue) | **PUT** /catalogues/{catalogueId} | Update catalogue
*KykyapiClient.CustomerOrganizationApi* | [**createCustomerOrganization**](docs/CustomerOrganizationApi.md#createCustomerOrganization) | **POST** /customerOrganizations | Create customer organization
*KykyapiClient.CustomerOrganizationApi* | [**deleteCustomerOrganization**](docs/CustomerOrganizationApi.md#deleteCustomerOrganization) | **DELETE** /customerOrganizations/{customerOrganizationId} | Delete customer organization
*KykyapiClient.CustomerOrganizationApi* | [**findCustomerOrganization**](docs/CustomerOrganizationApi.md#findCustomerOrganization) | **GET** /customerOrganizations/{customerOrganizationId} | Find customer organization
*KykyapiClient.CustomerOrganizationApi* | [**listCustomerOrganizations**](docs/CustomerOrganizationApi.md#listCustomerOrganizations) | **GET** /customerOrganizations | List customerOrganizations
*KykyapiClient.CustomerOrganizationApi* | [**updateCustomerOrganization**](docs/CustomerOrganizationApi.md#updateCustomerOrganization) | **PUT** /customerOrganizations/{customerOrganizationId} | Update customer organization
*KykyapiClient.CustomerRepresentativeApi* | [**createCustomerRepresentative**](docs/CustomerRepresentativeApi.md#createCustomerRepresentative) | **POST** /customerRepresentatives | Create customer representative
*KykyapiClient.CustomerRepresentativeApi* | [**deleteCustomerRepresentative**](docs/CustomerRepresentativeApi.md#deleteCustomerRepresentative) | **DELETE** /customerRepresentatives/{customerRepresentativeId} | Delete customer representative
*KykyapiClient.CustomerRepresentativeApi* | [**findCustomerRepresentative**](docs/CustomerRepresentativeApi.md#findCustomerRepresentative) | **GET** /customerRepresentatives/{customerRepresentativeId} | Find customer representative
*KykyapiClient.CustomerRepresentativeApi* | [**listCustomerRepresentatives**](docs/CustomerRepresentativeApi.md#listCustomerRepresentatives) | **GET** /customerRepresentatives | List customer representatives
*KykyapiClient.CustomerRepresentativeApi* | [**updateCustomerRepresentative**](docs/CustomerRepresentativeApi.md#updateCustomerRepresentative) | **PUT** /customerRepresentatives/{customerRepresentativeId} | Update customer representative
*KykyapiClient.InternalOrderApi* | [**createInternalOrder**](docs/InternalOrderApi.md#createInternalOrder) | **POST** /internalOrders | Create internal order
*KykyapiClient.InternalOrderApi* | [**deleteInternalOrder**](docs/InternalOrderApi.md#deleteInternalOrder) | **DELETE** /internalOrders/{internalOrderId} | Delete internal order
*KykyapiClient.InternalOrderApi* | [**findInternalOrder**](docs/InternalOrderApi.md#findInternalOrder) | **GET** /internalOrders/{internalOrderId} | Find internal order
*KykyapiClient.InternalOrderApi* | [**listInternalOrders**](docs/InternalOrderApi.md#listInternalOrders) | **GET** /internalOrders | List internal orders
*KykyapiClient.InternalOrderApi* | [**updateInternalOrder**](docs/InternalOrderApi.md#updateInternalOrder) | **PUT** /internalOrders/{internalOrderId} | Update internal order
*KykyapiClient.InvoicesApi* | [**createInvoice**](docs/InvoicesApi.md#createInvoice) | **POST** /invoices | Create invoice
*KykyapiClient.ListProductApi* | [**createListProduct**](docs/ListProductApi.md#createListProduct) | **POST** /listProducts | Create list product
*KykyapiClient.ListProductApi* | [**deleteListProduct**](docs/ListProductApi.md#deleteListProduct) | **DELETE** /listProducts/{listProductId} | Delete a list product
*KykyapiClient.ListProductApi* | [**findListProduct**](docs/ListProductApi.md#findListProduct) | **GET** /listProducts/{listProductId} | Find a list product
*KykyapiClient.ListProductApi* | [**listListProducts**](docs/ListProductApi.md#listListProducts) | **GET** /listProducts | List list products
*KykyapiClient.ListProductApi* | [**updateListProduct**](docs/ListProductApi.md#updateListProduct) | **PUT** /listProducts/{listProductId} | Update list product
*KykyapiClient.PurchaseOfferRequestApi* | [**createPurchaseOfferRequest**](docs/PurchaseOfferRequestApi.md#createPurchaseOfferRequest) | **POST** /purchaseOfferRequests | Create purchase offer request
*KykyapiClient.PurchaseOfferRequestApi* | [**deletePurchaseOfferRequest**](docs/PurchaseOfferRequestApi.md#deletePurchaseOfferRequest) | **DELETE** /purchaseOfferRequests/{purchaseOfferRequestId} | Delete purchase offer request
*KykyapiClient.PurchaseOfferRequestApi* | [**findPurchaseOfferRequest**](docs/PurchaseOfferRequestApi.md#findPurchaseOfferRequest) | **GET** /purchaseOfferRequests/{purchaseOfferRequestId} | Find purchase offer request
*KykyapiClient.PurchaseOfferRequestApi* | [**getPurchaseOfferRequestsPdf**](docs/PurchaseOfferRequestApi.md#getPurchaseOfferRequestsPdf) | **GET** /purchaseOfferRequests/{purchaseOfferRequestId}/pdf | Get purchase offer request PDF
*KykyapiClient.PurchaseOfferRequestApi* | [**listPurchaseOfferRequests**](docs/PurchaseOfferRequestApi.md#listPurchaseOfferRequests) | **GET** /purchaseOfferRequests | List purchase offer requests
*KykyapiClient.PurchaseOfferRequestApi* | [**updatePurchaseOfferRequest**](docs/PurchaseOfferRequestApi.md#updatePurchaseOfferRequest) | **PUT** /purchaseOfferRequests/{purchaseOfferRequestId} | Update purchase offer request
*KykyapiClient.PurchaseOrderApi* | [**createPurchaseOrder**](docs/PurchaseOrderApi.md#createPurchaseOrder) | **POST** /purchaseOrders | Create purchase order
*KykyapiClient.PurchaseOrderApi* | [**deletePurchaseOrder**](docs/PurchaseOrderApi.md#deletePurchaseOrder) | **DELETE** /purchaseOrders/{purchaseOrderId} | Delete purchase order
*KykyapiClient.PurchaseOrderApi* | [**findPurchaseOrder**](docs/PurchaseOrderApi.md#findPurchaseOrder) | **GET** /purchaseOrders/{purchaseOrderId} | Find purchase order
*KykyapiClient.PurchaseOrderApi* | [**getPurchaseOrderPdf**](docs/PurchaseOrderApi.md#getPurchaseOrderPdf) | **GET** /purchaseOrders/{purchaseOrderId}/pdf | Get purchase order PDF
*KykyapiClient.PurchaseOrderApi* | [**listPurchaseOrders**](docs/PurchaseOrderApi.md#listPurchaseOrders) | **GET** /purchaseOrders | List purchase orders
*KykyapiClient.PurchaseOrderApi* | [**updatePurchaseOrder**](docs/PurchaseOrderApi.md#updatePurchaseOrder) | **PUT** /purchaseOrders/{purchaseOrderId} | Update purchase order
*KykyapiClient.RowProductApi* | [**createRowProduct**](docs/RowProductApi.md#createRowProduct) | **POST** /rowProducts | Create row product
*KykyapiClient.RowProductApi* | [**deleteRowProduct**](docs/RowProductApi.md#deleteRowProduct) | **DELETE** /rowProducts/{rowProductId} | Delete row product
*KykyapiClient.RowProductApi* | [**findRowProduct**](docs/RowProductApi.md#findRowProduct) | **GET** /rowProducts/{rowProductId} | Find row product
*KykyapiClient.RowProductApi* | [**listRowProducts**](docs/RowProductApi.md#listRowProducts) | **GET** /rowProducts | List row products
*KykyapiClient.RowProductApi* | [**updateRowProduct**](docs/RowProductApi.md#updateRowProduct) | **PUT** /rowProducts/{rowProductId} | Update row product
*KykyapiClient.SaleApi* | [**createSale**](docs/SaleApi.md#createSale) | **POST** /sales | Create sale
*KykyapiClient.SaleApi* | [**deleteSale**](docs/SaleApi.md#deleteSale) | **DELETE** /sales/{saleId} | Delete sale
*KykyapiClient.SaleApi* | [**findSale**](docs/SaleApi.md#findSale) | **GET** /sales/{saleId} | Find sale
*KykyapiClient.SaleApi* | [**listSales**](docs/SaleApi.md#listSales) | **GET** /sales | List sales
*KykyapiClient.SaleApi* | [**updateSale**](docs/SaleApi.md#updateSale) | **PUT** /sales/{saleId} | Update sale
*KykyapiClient.SaleOfferApi* | [**createSaleOffer**](docs/SaleOfferApi.md#createSaleOffer) | **POST** /saleOffers | Create sale offer
*KykyapiClient.SaleOfferApi* | [**deleteSaleOffer**](docs/SaleOfferApi.md#deleteSaleOffer) | **DELETE** /saleOffers/{saleOfferId} | Delete sale offer
*KykyapiClient.SaleOfferApi* | [**findSaleOffer**](docs/SaleOfferApi.md#findSaleOffer) | **GET** /saleOffers/{saleOfferId} | Find sale offer
*KykyapiClient.SaleOfferApi* | [**getSaleOfferPdf**](docs/SaleOfferApi.md#getSaleOfferPdf) | **GET** /saleOffers/{saleOfferId}/pdf | Get sale offer PDF
*KykyapiClient.SaleOfferApi* | [**listSaleOffers**](docs/SaleOfferApi.md#listSaleOffers) | **GET** /saleOffers | List sale offers
*KykyapiClient.SaleOfferApi* | [**updateSaleOffer**](docs/SaleOfferApi.md#updateSaleOffer) | **PUT** /saleOffers/{saleOfferId} | Update sale offer
*KykyapiClient.SaleOrderApi* | [**createSaleOrder**](docs/SaleOrderApi.md#createSaleOrder) | **POST** /saleOrders | Create sale order
*KykyapiClient.SaleOrderApi* | [**deleteSaleOrder**](docs/SaleOrderApi.md#deleteSaleOrder) | **DELETE** /saleOrders/{saleOrderId} | Delete sale order
*KykyapiClient.SaleOrderApi* | [**findSaleOrder**](docs/SaleOrderApi.md#findSaleOrder) | **GET** /saleOrders/{saleOrderId} | Find sale order
*KykyapiClient.SaleOrderApi* | [**getSaleOrderPdf**](docs/SaleOrderApi.md#getSaleOrderPdf) | **GET** /saleOrders/{saleOrderId}/pdf | Get sale order PDF
*KykyapiClient.SaleOrderApi* | [**listSaleOrders**](docs/SaleOrderApi.md#listSaleOrders) | **GET** /saleOrders | List sale orders
*KykyapiClient.SaleOrderApi* | [**updateSaleOrder**](docs/SaleOrderApi.md#updateSaleOrder) | **PUT** /saleOrders/{saleOrderId} | Update sale order
*KykyapiClient.SchematicApi* | [**createSchematic**](docs/SchematicApi.md#createSchematic) | **POST** /schematics | Create schematic
*KykyapiClient.SchematicApi* | [**findSchematic**](docs/SchematicApi.md#findSchematic) | **GET** /schematics/{schematicId} | Find schematic
*KykyapiClient.SchematicApi* | [**findSchematicData**](docs/SchematicApi.md#findSchematicData) | **GET** /schematics/{schematicId}/data | Find schematic data
*KykyapiClient.SchematicApi* | [**listSchematics**](docs/SchematicApi.md#listSchematics) | **GET** /schematics | List schematics
*KykyapiClient.SchematicApi* | [**updateSchematic**](docs/SchematicApi.md#updateSchematic) | **PUT** /schematics/{schematicId} | Update schematic
*KykyapiClient.SchematicApi* | [**updateSchematicData**](docs/SchematicApi.md#updateSchematicData) | **PUT** /schematics/{schematicId}/data | Update schematic data
*KykyapiClient.StorageProductApi* | [**createStorageProduct**](docs/StorageProductApi.md#createStorageProduct) | **POST** /storageProducts | Create storage product
*KykyapiClient.StorageProductApi* | [**findStorageProduct**](docs/StorageProductApi.md#findStorageProduct) | **GET** /storageProducts/{storageProductId} | Find a storage product
*KykyapiClient.StorageProductApi* | [**listStorageProducts**](docs/StorageProductApi.md#listStorageProducts) | **GET** /storageProducts | List list products
*KykyapiClient.StorageProductApi* | [**updateStorageProduct**](docs/StorageProductApi.md#updateStorageProduct) | **PUT** /storageProducts/{storageProductId} | Update storage product


## Documentation for Models

 - [KykyapiClient.Address](docs/Address.md)
 - [KykyapiClient.Attachment](docs/Attachment.md)
 - [KykyapiClient.BadRequest](docs/BadRequest.md)
 - [KykyapiClient.Catalogue](docs/Catalogue.md)
 - [KykyapiClient.CatalogueProduct](docs/CatalogueProduct.md)
 - [KykyapiClient.CustomerOrganization](docs/CustomerOrganization.md)
 - [KykyapiClient.CustomerRepresentative](docs/CustomerRepresentative.md)
 - [KykyapiClient.Forbidden](docs/Forbidden.md)
 - [KykyapiClient.InternalOrder](docs/InternalOrder.md)
 - [KykyapiClient.InternalServerError](docs/InternalServerError.md)
 - [KykyapiClient.InvoiceModel](docs/InvoiceModel.md)
 - [KykyapiClient.ListProduct](docs/ListProduct.md)
 - [KykyapiClient.NotFound](docs/NotFound.md)
 - [KykyapiClient.NotImplemented](docs/NotImplemented.md)
 - [KykyapiClient.PurchaseOfferRequest](docs/PurchaseOfferRequest.md)
 - [KykyapiClient.PurchaseOrder](docs/PurchaseOrder.md)
 - [KykyapiClient.PurchaseOrderInvoice](docs/PurchaseOrderInvoice.md)
 - [KykyapiClient.RowProduct](docs/RowProduct.md)
 - [KykyapiClient.RowProductDetail](docs/RowProductDetail.md)
 - [KykyapiClient.Sale](docs/Sale.md)
 - [KykyapiClient.SaleOffer](docs/SaleOffer.md)
 - [KykyapiClient.SaleOrder](docs/SaleOrder.md)
 - [KykyapiClient.Schematic](docs/Schematic.md)
 - [KykyapiClient.StorageProduct](docs/StorageProduct.md)


## Documentation for Authorization


### bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

