# KykyapiClient.CataloguesApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createCatalogue**](CataloguesApi.md#createCatalogue) | **POST** /catalogues | Create catalogue
[**deleteCatalogue**](CataloguesApi.md#deleteCatalogue) | **DELETE** /catalogues/{catalogueId} | Delete catalogue
[**findCatalogue**](CataloguesApi.md#findCatalogue) | **GET** /catalogues/{catalogueId} | Find catalogue
[**listCatalogues**](CataloguesApi.md#listCatalogues) | **GET** /catalogues | List catalogues
[**updateCatalogue**](CataloguesApi.md#updateCatalogue) | **PUT** /catalogues/{catalogueId} | Update catalogue


<a name="createCatalogue"></a>
# **createCatalogue**
> Catalogue createCatalogue(body)

Create catalogue

Creates new catalogue

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CataloguesApi();

var body = new KykyapiClient.Catalogue(); // Catalogue | Payload

apiInstance.createCatalogue(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Catalogue**](Catalogue.md)| Payload | 

### Return type

[**Catalogue**](Catalogue.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteCatalogue"></a>
# **deleteCatalogue**
> deleteCatalogue(catalogueId)

Delete catalogue

deletes single catalogue

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CataloguesApi();

var catalogueId = 789; // Number | catalogue id

apiInstance.deleteCatalogue(catalogueId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **catalogueId** | **Number**| catalogue id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findCatalogue"></a>
# **findCatalogue**
> Catalogue findCatalogue(catalogueId)

Find catalogue

Returns single catalogue

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CataloguesApi();

var catalogueId = 789; // Number | catalogue id

apiInstance.findCatalogue(catalogueId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **catalogueId** | **Number**| catalogue id | 

### Return type

[**Catalogue**](Catalogue.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listCatalogues"></a>
# **listCatalogues**
> [Catalogue] listCatalogues()

List catalogues

list catalogues

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CataloguesApi();
apiInstance.listCatalogues().then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters
This endpoint does not need any parameter.

### Return type

[**[Catalogue]**](Catalogue.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateCatalogue"></a>
# **updateCatalogue**
> Catalogue updateCatalogue(catalogueId, body)

Update catalogue

Updates a catalogue

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CataloguesApi();

var catalogueId = 789; // Number | catalogue id

var body = new KykyapiClient.Catalogue(); // Catalogue | Payload

apiInstance.updateCatalogue(catalogueId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **catalogueId** | **Number**| catalogue id | 
 **body** | [**Catalogue**](Catalogue.md)| Payload | 

### Return type

[**Catalogue**](Catalogue.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

