# KykyapiClient.CustomerOrganizationApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createCustomerOrganization**](CustomerOrganizationApi.md#createCustomerOrganization) | **POST** /customerOrganizations | Create customer organization
[**deleteCustomerOrganization**](CustomerOrganizationApi.md#deleteCustomerOrganization) | **DELETE** /customerOrganizations/{customerOrganizationId} | Delete customer organization
[**findCustomerOrganization**](CustomerOrganizationApi.md#findCustomerOrganization) | **GET** /customerOrganizations/{customerOrganizationId} | Find customer organization
[**listCustomerOrganizations**](CustomerOrganizationApi.md#listCustomerOrganizations) | **GET** /customerOrganizations | List customerOrganizations
[**updateCustomerOrganization**](CustomerOrganizationApi.md#updateCustomerOrganization) | **PUT** /customerOrganizations/{customerOrganizationId} | Update customer organization


<a name="createCustomerOrganization"></a>
# **createCustomerOrganization**
> CustomerOrganization createCustomerOrganization(body)

Create customer organization

Creates new customer organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CustomerOrganizationApi();

var body = new KykyapiClient.CustomerOrganization(); // CustomerOrganization | Payload

apiInstance.createCustomerOrganization(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**CustomerOrganization**](CustomerOrganization.md)| Payload | 

### Return type

[**CustomerOrganization**](CustomerOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteCustomerOrganization"></a>
# **deleteCustomerOrganization**
> deleteCustomerOrganization(customerOrganizationId)

Delete customer organization

deletes single customer organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CustomerOrganizationApi();

var customerOrganizationId = 789; // Number | customer organization id

apiInstance.deleteCustomerOrganization(customerOrganizationId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerOrganizationId** | **Number**| customer organization id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findCustomerOrganization"></a>
# **findCustomerOrganization**
> CustomerOrganization findCustomerOrganization(customerOrganizationId)

Find customer organization

Returns single customer organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CustomerOrganizationApi();

var customerOrganizationId = 789; // Number | customer organization id

apiInstance.findCustomerOrganization(customerOrganizationId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerOrganizationId** | **Number**| customer organization id | 

### Return type

[**CustomerOrganization**](CustomerOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listCustomerOrganizations"></a>
# **listCustomerOrganizations**
> [CustomerOrganization] listCustomerOrganizations(opts)

List customerOrganizations

list customer organizations

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CustomerOrganizationApi();

var opts = { 
  'type': "type_example" // String | filter by customer organization type, one of CUSTOMER, SUPPLIER
};
apiInstance.listCustomerOrganizations(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **String**| filter by customer organization type, one of CUSTOMER, SUPPLIER | [optional] 

### Return type

[**[CustomerOrganization]**](CustomerOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateCustomerOrganization"></a>
# **updateCustomerOrganization**
> CustomerOrganization updateCustomerOrganization(customerOrganizationId, body)

Update customer organization

Updates a customer organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.CustomerOrganizationApi();

var customerOrganizationId = 789; // Number | customer organization id

var body = new KykyapiClient.CustomerOrganization(); // CustomerOrganization | Payload

apiInstance.updateCustomerOrganization(customerOrganizationId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **customerOrganizationId** | **Number**| customer organization id | 
 **body** | [**CustomerOrganization**](CustomerOrganization.md)| Payload | 

### Return type

[**CustomerOrganization**](CustomerOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

