# KykyapiClient.InternalOrderApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createInternalOrder**](InternalOrderApi.md#createInternalOrder) | **POST** /internalOrders | Create internal order
[**deleteInternalOrder**](InternalOrderApi.md#deleteInternalOrder) | **DELETE** /internalOrders/{internalOrderId} | Delete internal order
[**findInternalOrder**](InternalOrderApi.md#findInternalOrder) | **GET** /internalOrders/{internalOrderId} | Find internal order
[**listInternalOrders**](InternalOrderApi.md#listInternalOrders) | **GET** /internalOrders | List internal orders
[**updateInternalOrder**](InternalOrderApi.md#updateInternalOrder) | **PUT** /internalOrders/{internalOrderId} | Update internal order


<a name="createInternalOrder"></a>
# **createInternalOrder**
> InternalOrder createInternalOrder(body)

Create internal order

Creates new internal order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.InternalOrderApi();

var body = new KykyapiClient.InternalOrder(); // InternalOrder | Payload

apiInstance.createInternalOrder(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**InternalOrder**](InternalOrder.md)| Payload | 

### Return type

[**InternalOrder**](InternalOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteInternalOrder"></a>
# **deleteInternalOrder**
> deleteInternalOrder(internalOrderId)

Delete internal order

deletets single internal order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.InternalOrderApi();

var internalOrderId = 789; // Number | internal order id

apiInstance.deleteInternalOrder(internalOrderId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **internalOrderId** | **Number**| internal order id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findInternalOrder"></a>
# **findInternalOrder**
> InternalOrder findInternalOrder(internalOrderId)

Find internal order

Returns single internal order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.InternalOrderApi();

var internalOrderId = 789; // Number | internal order id

apiInstance.findInternalOrder(internalOrderId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **internalOrderId** | **Number**| internal order id | 

### Return type

[**InternalOrder**](InternalOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listInternalOrders"></a>
# **listInternalOrders**
> [InternalOrder] listInternalOrders(saleId)

List internal orders

List internal orders

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.InternalOrderApi();

var saleId = 789; // Number | filter by sale id

apiInstance.listInternalOrders(saleId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleId** | **Number**| filter by sale id | 

### Return type

[**[InternalOrder]**](InternalOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateInternalOrder"></a>
# **updateInternalOrder**
> InternalOrder updateInternalOrder(internalOrderId, body)

Update internal order

Updates a internal order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.InternalOrderApi();

var internalOrderId = 789; // Number | sale order id

var body = new KykyapiClient.InternalOrder(); // InternalOrder | Payload

apiInstance.updateInternalOrder(internalOrderId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **internalOrderId** | **Number**| sale order id | 
 **body** | [**InternalOrder**](InternalOrder.md)| Payload | 

### Return type

[**InternalOrder**](InternalOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

