# KykyapiClient.ListProductApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createListProduct**](ListProductApi.md#createListProduct) | **POST** /listProducts | Create list product
[**deleteListProduct**](ListProductApi.md#deleteListProduct) | **DELETE** /listProducts/{listProductId} | Delete a list product
[**findListProduct**](ListProductApi.md#findListProduct) | **GET** /listProducts/{listProductId} | Find a list product
[**listListProducts**](ListProductApi.md#listListProducts) | **GET** /listProducts | List list products
[**updateListProduct**](ListProductApi.md#updateListProduct) | **PUT** /listProducts/{listProductId} | Update list product


<a name="createListProduct"></a>
# **createListProduct**
> ListProduct createListProduct(body)

Create list product

Create list list product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.ListProductApi();

var body = new KykyapiClient.ListProduct(); // ListProduct | Payload

apiInstance.createListProduct(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ListProduct**](ListProduct.md)| Payload | 

### Return type

[**ListProduct**](ListProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteListProduct"></a>
# **deleteListProduct**
> deleteListProduct(listProductId)

Delete a list product

Deletes single list product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.ListProductApi();

var listProductId = 789; // Number | list product id

apiInstance.deleteListProduct(listProductId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **listProductId** | **Number**| list product id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findListProduct"></a>
# **findListProduct**
> ListProduct findListProduct(listProductId)

Find a list product

Returns single list product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.ListProductApi();

var listProductId = 789; // Number | list product id

apiInstance.findListProduct(listProductId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **listProductId** | **Number**| list product id | 

### Return type

[**ListProduct**](ListProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listListProducts"></a>
# **listListProducts**
> [ListProduct] listListProducts(opts)

List list products

list list products

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.ListProductApi();

var opts = { 
  'category': "category_example" // String | Filter results by category
};
apiInstance.listListProducts(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **category** | **String**| Filter results by category | [optional] 

### Return type

[**[ListProduct]**](ListProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateListProduct"></a>
# **updateListProduct**
> ListProduct updateListProduct(listProductId, body)

Update list product

Updates a list product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.ListProductApi();

var listProductId = 789; // Number | list product id

var body = new KykyapiClient.ListProduct(); // ListProduct | Payload

apiInstance.updateListProduct(listProductId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **listProductId** | **Number**| list product id | 
 **body** | [**ListProduct**](ListProduct.md)| Payload | 

### Return type

[**ListProduct**](ListProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

