# KykyapiClient.PurchaseOfferRequestApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createPurchaseOfferRequest**](PurchaseOfferRequestApi.md#createPurchaseOfferRequest) | **POST** /purchaseOfferRequests | Create purchase offer request
[**deletePurchaseOfferRequest**](PurchaseOfferRequestApi.md#deletePurchaseOfferRequest) | **DELETE** /purchaseOfferRequests/{purchaseOfferRequestId} | Delete purchase offer request
[**findPurchaseOfferRequest**](PurchaseOfferRequestApi.md#findPurchaseOfferRequest) | **GET** /purchaseOfferRequests/{purchaseOfferRequestId} | Find purchase offer request
[**getPurchaseOfferRequestsPdf**](PurchaseOfferRequestApi.md#getPurchaseOfferRequestsPdf) | **GET** /purchaseOfferRequests/{purchaseOfferRequestId}/pdf | Get purchase offer request PDF
[**listPurchaseOfferRequests**](PurchaseOfferRequestApi.md#listPurchaseOfferRequests) | **GET** /purchaseOfferRequests | List purchase offer requests
[**updatePurchaseOfferRequest**](PurchaseOfferRequestApi.md#updatePurchaseOfferRequest) | **PUT** /purchaseOfferRequests/{purchaseOfferRequestId} | Update purchase offer request


<a name="createPurchaseOfferRequest"></a>
# **createPurchaseOfferRequest**
> PurchaseOfferRequest createPurchaseOfferRequest(body)

Create purchase offer request

Create purchase offer request

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.PurchaseOfferRequestApi();

var body = new KykyapiClient.PurchaseOfferRequest(); // PurchaseOfferRequest | Payload

apiInstance.createPurchaseOfferRequest(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PurchaseOfferRequest**](PurchaseOfferRequest.md)| Payload | 

### Return type

[**PurchaseOfferRequest**](PurchaseOfferRequest.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deletePurchaseOfferRequest"></a>
# **deletePurchaseOfferRequest**
> deletePurchaseOfferRequest(purchaseOfferRequestId)

Delete purchase offer request

Delete purchase offer request

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.PurchaseOfferRequestApi();

var purchaseOfferRequestId = 789; // Number | sale order id

apiInstance.deletePurchaseOfferRequest(purchaseOfferRequestId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **purchaseOfferRequestId** | **Number**| sale order id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findPurchaseOfferRequest"></a>
# **findPurchaseOfferRequest**
> PurchaseOfferRequest findPurchaseOfferRequest(purchaseOfferRequestId)

Find purchase offer request

Find purchase offer request

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.PurchaseOfferRequestApi();

var purchaseOfferRequestId = 789; // Number | sale order id

apiInstance.findPurchaseOfferRequest(purchaseOfferRequestId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **purchaseOfferRequestId** | **Number**| sale order id | 

### Return type

[**PurchaseOfferRequest**](PurchaseOfferRequest.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="getPurchaseOfferRequestsPdf"></a>
# **getPurchaseOfferRequestsPdf**
> &#39;Blob&#39; getPurchaseOfferRequestsPdf(purchaseOfferRequestId, type)

Get purchase offer request PDF

Returns purchase offer request PDF

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.PurchaseOfferRequestApi();

var purchaseOfferRequestId = 789; // Number | purchase offer request id

var type = "type_example"; // String | Specifies returned PDF type. One of PURCHASE_OFFER_REQUEST

apiInstance.getPurchaseOfferRequestsPdf(purchaseOfferRequestId, type).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **purchaseOfferRequestId** | **Number**| purchase offer request id | 
 **type** | **String**| Specifies returned PDF type. One of PURCHASE_OFFER_REQUEST | 

### Return type

**&#39;Blob&#39;**

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listPurchaseOfferRequests"></a>
# **listPurchaseOfferRequests**
> [PurchaseOfferRequest] listPurchaseOfferRequests(opts)

List purchase offer requests

List purchase offer requests

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.PurchaseOfferRequestApi();

var opts = { 
  'saleId': 789, // Number | filter purchase offer requests by sale id
  'firstResult': 56, // Number | start from result
  'maxResults': 56 // Number | limit with max results
};
apiInstance.listPurchaseOfferRequests(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleId** | **Number**| filter purchase offer requests by sale id | [optional] 
 **firstResult** | **Number**| start from result | [optional] 
 **maxResults** | **Number**| limit with max results | [optional] 

### Return type

[**[PurchaseOfferRequest]**](PurchaseOfferRequest.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updatePurchaseOfferRequest"></a>
# **updatePurchaseOfferRequest**
> PurchaseOfferRequest updatePurchaseOfferRequest(purchaseOfferRequestId, body)

Update purchase offer request

Update purchase offer request

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.PurchaseOfferRequestApi();

var purchaseOfferRequestId = 789; // Number | sale order id

var body = new KykyapiClient.PurchaseOfferRequest(); // PurchaseOfferRequest | Payload

apiInstance.updatePurchaseOfferRequest(purchaseOfferRequestId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **purchaseOfferRequestId** | **Number**| sale order id | 
 **body** | [**PurchaseOfferRequest**](PurchaseOfferRequest.md)| Payload | 

### Return type

[**PurchaseOfferRequest**](PurchaseOfferRequest.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

