# KykyapiClient.RowProductApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createRowProduct**](RowProductApi.md#createRowProduct) | **POST** /rowProducts | Create row product
[**deleteRowProduct**](RowProductApi.md#deleteRowProduct) | **DELETE** /rowProducts/{rowProductId} | Delete row product
[**findRowProduct**](RowProductApi.md#findRowProduct) | **GET** /rowProducts/{rowProductId} | Find row product
[**listRowProducts**](RowProductApi.md#listRowProducts) | **GET** /rowProducts | List row products
[**updateRowProduct**](RowProductApi.md#updateRowProduct) | **PUT** /rowProducts/{rowProductId} | Update row product


<a name="createRowProduct"></a>
# **createRowProduct**
> RowProduct createRowProduct(body)

Create row product

Creates new row product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.RowProductApi();

var body = new KykyapiClient.RowProduct(); // RowProduct | Payload

apiInstance.createRowProduct(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**RowProduct**](RowProduct.md)| Payload | 

### Return type

[**RowProduct**](RowProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteRowProduct"></a>
# **deleteRowProduct**
> deleteRowProduct(rowProductId)

Delete row product

Deletes a row product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.RowProductApi();

var rowProductId = 789; // Number | row product id

apiInstance.deleteRowProduct(rowProductId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rowProductId** | **Number**| row product id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findRowProduct"></a>
# **findRowProduct**
> RowProduct findRowProduct(rowProductId)

Find row product

Returns single row product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.RowProductApi();

var rowProductId = 789; // Number | row product id

apiInstance.findRowProduct(rowProductId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rowProductId** | **Number**| row product id | 

### Return type

[**RowProduct**](RowProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listRowProducts"></a>
# **listRowProducts**
> [RowProduct] listRowProducts(parentId, parentType)

List row products

Returns list of row products

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.RowProductApi();

var parentId = 789; // Number | parent id of row product

var parentType = "parentType_example"; // String | parent type of row product

apiInstance.listRowProducts(parentId, parentType).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parentId** | **Number**| parent id of row product | 
 **parentType** | **String**| parent type of row product | 

### Return type

[**[RowProduct]**](RowProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateRowProduct"></a>
# **updateRowProduct**
> RowProduct updateRowProduct(rowProductId, body)

Update row product

Updates a row product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.RowProductApi();

var rowProductId = 789; // Number | row product id

var body = new KykyapiClient.RowProduct(); // RowProduct | Payload

apiInstance.updateRowProduct(rowProductId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rowProductId** | **Number**| row product id | 
 **body** | [**RowProduct**](RowProduct.md)| Payload | 

### Return type

[**RowProduct**](RowProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

