# KykyapiClient.SaleOfferApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSaleOffer**](SaleOfferApi.md#createSaleOffer) | **POST** /saleOffers | Create sale offer
[**deleteSaleOffer**](SaleOfferApi.md#deleteSaleOffer) | **DELETE** /saleOffers/{saleOfferId} | Delete sale offer
[**findSaleOffer**](SaleOfferApi.md#findSaleOffer) | **GET** /saleOffers/{saleOfferId} | Find sale offer
[**getSaleOfferPdf**](SaleOfferApi.md#getSaleOfferPdf) | **GET** /saleOffers/{saleOfferId}/pdf | Get sale offer PDF
[**listSaleOffers**](SaleOfferApi.md#listSaleOffers) | **GET** /saleOffers | List sale offers
[**updateSaleOffer**](SaleOfferApi.md#updateSaleOffer) | **PUT** /saleOffers/{saleOfferId} | Update sale offer


<a name="createSaleOffer"></a>
# **createSaleOffer**
> SaleOffer createSaleOffer(body)

Create sale offer

Creates new sale offer

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOfferApi();

var body = new KykyapiClient.SaleOffer(); // SaleOffer | Payload

apiInstance.createSaleOffer(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SaleOffer**](SaleOffer.md)| Payload | 

### Return type

[**SaleOffer**](SaleOffer.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteSaleOffer"></a>
# **deleteSaleOffer**
> deleteSaleOffer(saleOfferId)

Delete sale offer

Deletes single sale offer

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOfferApi();

var saleOfferId = 789; // Number | sale offer id

apiInstance.deleteSaleOffer(saleOfferId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOfferId** | **Number**| sale offer id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findSaleOffer"></a>
# **findSaleOffer**
> SaleOffer findSaleOffer(saleOfferId)

Find sale offer

Returns single sale offer

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOfferApi();

var saleOfferId = 789; // Number | sale offer id

apiInstance.findSaleOffer(saleOfferId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOfferId** | **Number**| sale offer id | 

### Return type

[**SaleOffer**](SaleOffer.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="getSaleOfferPdf"></a>
# **getSaleOfferPdf**
> &#39;Blob&#39; getSaleOfferPdf(saleOfferId, type)

Get sale offer PDF

Returns sale offer PDF

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOfferApi();

var saleOfferId = 789; // Number | sale offer id

var type = "type_example"; // String | Specifies returned PDF type. One of SALE_OFFER

apiInstance.getSaleOfferPdf(saleOfferId, type).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOfferId** | **Number**| sale offer id | 
 **type** | **String**| Specifies returned PDF type. One of SALE_OFFER | 

### Return type

**&#39;Blob&#39;**

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listSaleOffers"></a>
# **listSaleOffers**
> [SaleOffer] listSaleOffers(opts)

List sale offers

List sale offers

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOfferApi();

var opts = { 
  'saleId': 789 // Number | filter sale offerts by sale id
};
apiInstance.listSaleOffers(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleId** | **Number**| filter sale offerts by sale id | [optional] 

### Return type

[**[SaleOffer]**](SaleOffer.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateSaleOffer"></a>
# **updateSaleOffer**
> SaleOffer updateSaleOffer(saleOfferId, body)

Update sale offer

Updates a sale offer

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOfferApi();

var saleOfferId = 789; // Number | sale offer id

var body = new KykyapiClient.SaleOffer(); // SaleOffer | Payload

apiInstance.updateSaleOffer(saleOfferId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOfferId** | **Number**| sale offer id | 
 **body** | [**SaleOffer**](SaleOffer.md)| Payload | 

### Return type

[**SaleOffer**](SaleOffer.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

