# KykyapiClient.SaleOrderApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSaleOrder**](SaleOrderApi.md#createSaleOrder) | **POST** /saleOrders | Create sale order
[**deleteSaleOrder**](SaleOrderApi.md#deleteSaleOrder) | **DELETE** /saleOrders/{saleOrderId} | Delete sale order
[**findSaleOrder**](SaleOrderApi.md#findSaleOrder) | **GET** /saleOrders/{saleOrderId} | Find sale order
[**getSaleOrderPdf**](SaleOrderApi.md#getSaleOrderPdf) | **GET** /saleOrders/{saleOrderId}/pdf | Get sale order PDF
[**listSaleOrders**](SaleOrderApi.md#listSaleOrders) | **GET** /saleOrders | List sale orders
[**updateSaleOrder**](SaleOrderApi.md#updateSaleOrder) | **PUT** /saleOrders/{saleOrderId} | Update sale order


<a name="createSaleOrder"></a>
# **createSaleOrder**
> SaleOrder createSaleOrder(body)

Create sale order

Creates new sale order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOrderApi();

var body = new KykyapiClient.SaleOrder(); // SaleOrder | Payload

apiInstance.createSaleOrder(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SaleOrder**](SaleOrder.md)| Payload | 

### Return type

[**SaleOrder**](SaleOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="deleteSaleOrder"></a>
# **deleteSaleOrder**
> deleteSaleOrder(saleOrderId)

Delete sale order

Deletes single sale order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOrderApi();

var saleOrderId = 789; // Number | sale order id

apiInstance.deleteSaleOrder(saleOrderId).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOrderId** | **Number**| sale order id | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findSaleOrder"></a>
# **findSaleOrder**
> SaleOrder findSaleOrder(saleOrderId)

Find sale order

Returns single sale order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOrderApi();

var saleOrderId = 789; // Number | sale order id

apiInstance.findSaleOrder(saleOrderId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOrderId** | **Number**| sale order id | 

### Return type

[**SaleOrder**](SaleOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="getSaleOrderPdf"></a>
# **getSaleOrderPdf**
> &#39;Blob&#39; getSaleOrderPdf(saleOrderId, type)

Get sale order PDF

Returns sale order PDF

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOrderApi();

var saleOrderId = 789; // Number | sale order id

var type = "type_example"; // String | Specifies returned PDF type. One of ORDER_CONFIRMATION

apiInstance.getSaleOrderPdf(saleOrderId, type).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOrderId** | **Number**| sale order id | 
 **type** | **String**| Specifies returned PDF type. One of ORDER_CONFIRMATION | 

### Return type

**&#39;Blob&#39;**

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listSaleOrders"></a>
# **listSaleOrders**
> [SaleOrder] listSaleOrders(opts)

List sale orders

List sale orders

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOrderApi();

var opts = { 
  'saleId': 789, // Number | filter by sale id
  'deliveryTimeBefore': "deliveryTimeBefore_example", // String | return only saleorders that have delivery time before the date
  'deliveryTimeAfter': "deliveryTimeAfter_example" // String | return only saleorders that have delivery time after the date
};
apiInstance.listSaleOrders(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleId** | **Number**| filter by sale id | [optional] 
 **deliveryTimeBefore** | **String**| return only saleorders that have delivery time before the date | [optional] 
 **deliveryTimeAfter** | **String**| return only saleorders that have delivery time after the date | [optional] 

### Return type

[**[SaleOrder]**](SaleOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateSaleOrder"></a>
# **updateSaleOrder**
> SaleOrder updateSaleOrder(saleOrderId, body)

Update sale order

Updates a sale order

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SaleOrderApi();

var saleOrderId = 789; // Number | sale order id

var body = new KykyapiClient.SaleOrder(); // SaleOrder | Payload

apiInstance.updateSaleOrder(saleOrderId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saleOrderId** | **Number**| sale order id | 
 **body** | [**SaleOrder**](SaleOrder.md)| Payload | 

### Return type

[**SaleOrder**](SaleOrder.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

