# KykyapiClient.SchematicApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSchematic**](SchematicApi.md#createSchematic) | **POST** /schematics | Create schematic
[**findSchematic**](SchematicApi.md#findSchematic) | **GET** /schematics/{schematicId} | Find schematic
[**findSchematicData**](SchematicApi.md#findSchematicData) | **GET** /schematics/{schematicId}/data | Find schematic data
[**listSchematics**](SchematicApi.md#listSchematics) | **GET** /schematics | List schematics
[**updateSchematic**](SchematicApi.md#updateSchematic) | **PUT** /schematics/{schematicId} | Update schematic
[**updateSchematicData**](SchematicApi.md#updateSchematicData) | **PUT** /schematics/{schematicId}/data | Update schematic data


<a name="createSchematic"></a>
# **createSchematic**
> Schematic createSchematic(body)

Create schematic

Creates new schematic

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SchematicApi();

var body = new KykyapiClient.Schematic(); // Schematic | Payload

apiInstance.createSchematic(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Schematic**](Schematic.md)| Payload | 

### Return type

[**Schematic**](Schematic.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findSchematic"></a>
# **findSchematic**
> Schematic findSchematic(schematicId)

Find schematic

Returns single schematic

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SchematicApi();

var schematicId = 789; // Number | schematic id

apiInstance.findSchematic(schematicId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **schematicId** | **Number**| schematic id | 

### Return type

[**Schematic**](Schematic.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findSchematicData"></a>
# **findSchematicData**
> &#39;String&#39; findSchematicData(schematicId)

Find schematic data

Returns single schematic data

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SchematicApi();

var schematicId = 789; // Number | schematic id

apiInstance.findSchematicData(schematicId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **schematicId** | **Number**| schematic id | 

### Return type

**&#39;String&#39;**

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listSchematics"></a>
# **listSchematics**
> [Schematic] listSchematics(opts)

List schematics

list schematics

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SchematicApi();

var opts = { 
  'rowProductId': 789 // Number | Filter schematics by row product id
};
apiInstance.listSchematics(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **rowProductId** | **Number**| Filter schematics by row product id | [optional] 

### Return type

[**[Schematic]**](Schematic.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateSchematic"></a>
# **updateSchematic**
> Schematic updateSchematic(schematicId, body)

Update schematic

Updates a schematic

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SchematicApi();

var schematicId = 789; // Number | schematic id

var body = new KykyapiClient.Schematic(); // Schematic | Payload

apiInstance.updateSchematic(schematicId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **schematicId** | **Number**| schematic id | 
 **body** | [**Schematic**](Schematic.md)| Payload | 

### Return type

[**Schematic**](Schematic.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateSchematicData"></a>
# **updateSchematicData**
> updateSchematicData(schematicId, body)

Update schematic data

Updates a schematic data

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SchematicApi();

var schematicId = 789; // Number | schematic id

var body = "body_example"; // String | Payload

apiInstance.updateSchematicData(schematicId, body).then(function() {
  console.log('API called successfully.');
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **schematicId** | **Number**| schematic id | 
 **body** | **String**| Payload | 

### Return type

null (empty response body)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/x-www-form-urlencoded
 - **Accept**: application/json;charset=utf-8

