# KykyapiClient.StorageProductApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createStorageProduct**](StorageProductApi.md#createStorageProduct) | **POST** /storageProducts | Create storage product
[**findStorageProduct**](StorageProductApi.md#findStorageProduct) | **GET** /storageProducts/{storageProductId} | Find a storage product
[**listStorageProducts**](StorageProductApi.md#listStorageProducts) | **GET** /storageProducts | List list products
[**updateStorageProduct**](StorageProductApi.md#updateStorageProduct) | **PUT** /storageProducts/{storageProductId} | Update storage product


<a name="createStorageProduct"></a>
# **createStorageProduct**
> StorageProduct createStorageProduct(body)

Create storage product

Create storage product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.StorageProductApi();

var body = new KykyapiClient.StorageProduct(); // StorageProduct | Payload

apiInstance.createStorageProduct(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**StorageProduct**](StorageProduct.md)| Payload | 

### Return type

[**StorageProduct**](StorageProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findStorageProduct"></a>
# **findStorageProduct**
> StorageProduct findStorageProduct(storageProductId)

Find a storage product

Returns single storage product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.StorageProductApi();

var storageProductId = 789; // Number | storage product id

apiInstance.findStorageProduct(storageProductId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storageProductId** | **Number**| storage product id | 

### Return type

[**StorageProduct**](StorageProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listStorageProducts"></a>
# **listStorageProducts**
> [StorageProduct] listStorageProducts(opts)

List list products

list list products

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.StorageProductApi();

var opts = { 
  'listProductId': 789 // Number | Filter results by listProductId
};
apiInstance.listStorageProducts(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **listProductId** | **Number**| Filter results by listProductId | [optional] 

### Return type

[**[StorageProduct]**](StorageProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateStorageProduct"></a>
# **updateStorageProduct**
> StorageProduct updateStorageProduct(storageProductId, body)

Update storage product

Updates a storage product

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.StorageProductApi();

var storageProductId = 789; // Number | storage product id

var body = new KykyapiClient.StorageProduct(); // StorageProduct | Payload

apiInstance.updateStorageProduct(storageProductId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **storageProductId** | **Number**| storage product id | 
 **body** | [**StorageProduct**](StorageProduct.md)| Payload | 

### Return type

[**StorageProduct**](StorageProduct.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

