# KykyapiClient.SupplierOrganizationApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSupplierOrganization**](SupplierOrganizationApi.md#createSupplierOrganization) | **POST** /supplierOrganizations | Create supplier organization
[**findSupplierOrganization**](SupplierOrganizationApi.md#findSupplierOrganization) | **GET** /supplierOrganizations/{supplierOrganizationId} | Find supplier organization
[**listSupplierOrganizations**](SupplierOrganizationApi.md#listSupplierOrganizations) | **GET** /supplierOrganizations | List supplierOrganizations
[**updateSupplierOrganization**](SupplierOrganizationApi.md#updateSupplierOrganization) | **PUT** /supplierOrganizations/{supplierOrganizationId} | Update supplier organization


<a name="createSupplierOrganization"></a>
# **createSupplierOrganization**
> SupplierOrganization createSupplierOrganization(body)

Create supplier organization

Creates new supplier organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierOrganizationApi();

var body = new KykyapiClient.SupplierOrganization(); // SupplierOrganization | Payload

apiInstance.createSupplierOrganization(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SupplierOrganization**](SupplierOrganization.md)| Payload | 

### Return type

[**SupplierOrganization**](SupplierOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findSupplierOrganization"></a>
# **findSupplierOrganization**
> SupplierOrganization findSupplierOrganization(supplierOrganizationId)

Find supplier organization

Returns single supplier organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierOrganizationApi();

var supplierOrganizationId = 789; // Number | supplier organization id

apiInstance.findSupplierOrganization(supplierOrganizationId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **supplierOrganizationId** | **Number**| supplier organization id | 

### Return type

[**SupplierOrganization**](SupplierOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listSupplierOrganizations"></a>
# **listSupplierOrganizations**
> [SupplierOrganization] listSupplierOrganizations()

List supplierOrganizations

list supplier organizations

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierOrganizationApi();
apiInstance.listSupplierOrganizations().then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters
This endpoint does not need any parameter.

### Return type

[**[SupplierOrganization]**](SupplierOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateSupplierOrganization"></a>
# **updateSupplierOrganization**
> SupplierOrganization updateSupplierOrganization(supplierOrganizationId, body)

Update supplier organization

Updates a supplier organization

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierOrganizationApi();

var supplierOrganizationId = 789; // Number | supplier organization id

var body = new KykyapiClient.SupplierOrganization(); // SupplierOrganization | Payload

apiInstance.updateSupplierOrganization(supplierOrganizationId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **supplierOrganizationId** | **Number**| supplier organization id | 
 **body** | [**SupplierOrganization**](SupplierOrganization.md)| Payload | 

### Return type

[**SupplierOrganization**](SupplierOrganization.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

