# KykyapiClient.SupplierRepresentativeApi

All URIs are relative to *https://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createSupplierRepresentative**](SupplierRepresentativeApi.md#createSupplierRepresentative) | **POST** /supplierRepresentatives | Create supplier representative
[**findSupplierRepresentative**](SupplierRepresentativeApi.md#findSupplierRepresentative) | **GET** /supplierRepresentatives/{supplierRepresentativeId} | Find supplier representative
[**listSupplierRepresentatives**](SupplierRepresentativeApi.md#listSupplierRepresentatives) | **GET** /supplierRepresentatives | List supplier representatives
[**updateSupplierRepresentative**](SupplierRepresentativeApi.md#updateSupplierRepresentative) | **PUT** /supplierRepresentatives/{supplierRepresentativeId} | Update supplier representative


<a name="createSupplierRepresentative"></a>
# **createSupplierRepresentative**
> SupplierRepresentative createSupplierRepresentative(body)

Create supplier representative

Creates new supplier representative

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierRepresentativeApi();

var body = new KykyapiClient.SupplierRepresentative(); // SupplierRepresentative | Payload

apiInstance.createSupplierRepresentative(body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SupplierRepresentative**](SupplierRepresentative.md)| Payload | 

### Return type

[**SupplierRepresentative**](SupplierRepresentative.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="findSupplierRepresentative"></a>
# **findSupplierRepresentative**
> SupplierRepresentative findSupplierRepresentative(supplierRepresentativeId)

Find supplier representative

Returns single supplier representative

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierRepresentativeApi();

var supplierRepresentativeId = 789; // Number | supplier representative id

apiInstance.findSupplierRepresentative(supplierRepresentativeId).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **supplierRepresentativeId** | **Number**| supplier representative id | 

### Return type

[**SupplierRepresentative**](SupplierRepresentative.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="listSupplierRepresentatives"></a>
# **listSupplierRepresentatives**
> [SupplierRepresentative] listSupplierRepresentatives(opts)

List supplier representatives

list supplier representatives

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierRepresentativeApi();

var opts = { 
  'supplierOrganizationId': 789 // Number | filter by supplier organization id
};
apiInstance.listSupplierRepresentatives(opts).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **supplierOrganizationId** | **Number**| filter by supplier organization id | [optional] 

### Return type

[**[SupplierRepresentative]**](SupplierRepresentative.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

<a name="updateSupplierRepresentative"></a>
# **updateSupplierRepresentative**
> SupplierRepresentative updateSupplierRepresentative(supplierRepresentativeId, body)

Update supplier representative

Updates a supplier representative

### Example
```javascript
var KykyapiClient = require('kykyapi-client');
var defaultClient = KykyapiClient.ApiClient.instance;

// Configure API key authorization: bearer
var bearer = defaultClient.authentications['bearer'];
bearer.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearer.apiKeyPrefix = 'Token';

var apiInstance = new KykyapiClient.SupplierRepresentativeApi();

var supplierRepresentativeId = 789; // Number | supplier representative id

var body = new KykyapiClient.SupplierRepresentative(); // SupplierRepresentative | Payload

apiInstance.updateSupplierRepresentative(supplierRepresentativeId, body).then(function(data) {
  console.log('API called successfully. Returned data: ' + data);
}, function(error) {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **supplierRepresentativeId** | **Number**| supplier representative id | 
 **body** | [**SupplierRepresentative**](SupplierRepresentative.md)| Payload | 

### Return type

[**SupplierRepresentative**](SupplierRepresentative.md)

### Authorization

[bearer](../README.md#bearer)

### HTTP request headers

 - **Content-Type**: application/json;charset=utf-8
 - **Accept**: application/json;charset=utf-8

