/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Catalogue', 'model/Forbidden', 'model/InternalServerError'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Catalogue'), require('../model/Forbidden'), require('../model/InternalServerError'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.CataloguesApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Catalogue, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError);
  }
}(this, function(ApiClient, BadRequest, Catalogue, Forbidden, InternalServerError) {
  'use strict';

  /**
   * Catalogues service.
   * @module api/CataloguesApi
   * @version 0.0.83
   */

  /**
   * Constructs a new CataloguesApi. 
   * @alias module:api/CataloguesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create catalogue
     * Creates new catalogue
     * @param {module:model/Catalogue} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Catalogue} and HTTP response
     */
    this.createCatalogueWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createCatalogue");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Catalogue;

      return this.apiClient.callApi(
        '/catalogues', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create catalogue
     * Creates new catalogue
     * @param {module:model/Catalogue} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Catalogue}
     */
    this.createCatalogue = function(body) {
      return this.createCatalogueWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete catalogue
     * deletes single catalogue
     * @param {Number} catalogueId catalogue id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteCatalogueWithHttpInfo = function(catalogueId) {
      var postBody = null;

      // verify the required parameter 'catalogueId' is set
      if (catalogueId === undefined || catalogueId === null) {
        throw new Error("Missing the required parameter 'catalogueId' when calling deleteCatalogue");
      }


      var pathParams = {
        'catalogueId': catalogueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/catalogues/{catalogueId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete catalogue
     * deletes single catalogue
     * @param {Number} catalogueId catalogue id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteCatalogue = function(catalogueId) {
      return this.deleteCatalogueWithHttpInfo(catalogueId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find catalogue
     * Returns single catalogue
     * @param {Number} catalogueId catalogue id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Catalogue} and HTTP response
     */
    this.findCatalogueWithHttpInfo = function(catalogueId) {
      var postBody = null;

      // verify the required parameter 'catalogueId' is set
      if (catalogueId === undefined || catalogueId === null) {
        throw new Error("Missing the required parameter 'catalogueId' when calling findCatalogue");
      }


      var pathParams = {
        'catalogueId': catalogueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Catalogue;

      return this.apiClient.callApi(
        '/catalogues/{catalogueId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find catalogue
     * Returns single catalogue
     * @param {Number} catalogueId catalogue id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Catalogue}
     */
    this.findCatalogue = function(catalogueId) {
      return this.findCatalogueWithHttpInfo(catalogueId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List catalogues
     * list catalogues
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/Catalogue>} and HTTP response
     */
    this.listCataloguesWithHttpInfo = function() {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [Catalogue];

      return this.apiClient.callApi(
        '/catalogues', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List catalogues
     * list catalogues
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/Catalogue>}
     */
    this.listCatalogues = function() {
      return this.listCataloguesWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update catalogue
     * Updates a catalogue
     * @param {Number} catalogueId catalogue id
     * @param {module:model/Catalogue} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Catalogue} and HTTP response
     */
    this.updateCatalogueWithHttpInfo = function(catalogueId, body) {
      var postBody = body;

      // verify the required parameter 'catalogueId' is set
      if (catalogueId === undefined || catalogueId === null) {
        throw new Error("Missing the required parameter 'catalogueId' when calling updateCatalogue");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateCatalogue");
      }


      var pathParams = {
        'catalogueId': catalogueId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Catalogue;

      return this.apiClient.callApi(
        '/catalogues/{catalogueId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update catalogue
     * Updates a catalogue
     * @param {Number} catalogueId catalogue id
     * @param {module:model/Catalogue} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Catalogue}
     */
    this.updateCatalogue = function(catalogueId, body) {
      return this.updateCatalogueWithHttpInfo(catalogueId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
