/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/CustomerOrganization', 'model/Forbidden', 'model/InternalServerError'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/CustomerOrganization'), require('../model/Forbidden'), require('../model/InternalServerError'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.CustomerOrganizationApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.CustomerOrganization, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError);
  }
}(this, function(ApiClient, BadRequest, CustomerOrganization, Forbidden, InternalServerError) {
  'use strict';

  /**
   * CustomerOrganization service.
   * @module api/CustomerOrganizationApi
   * @version 0.0.83
   */

  /**
   * Constructs a new CustomerOrganizationApi. 
   * @alias module:api/CustomerOrganizationApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create customer organization
     * Creates new customer organization
     * @param {module:model/CustomerOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CustomerOrganization} and HTTP response
     */
    this.createCustomerOrganizationWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createCustomerOrganization");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = CustomerOrganization;

      return this.apiClient.callApi(
        '/customerOrganizations', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create customer organization
     * Creates new customer organization
     * @param {module:model/CustomerOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CustomerOrganization}
     */
    this.createCustomerOrganization = function(body) {
      return this.createCustomerOrganizationWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete customer organization
     * deletes single customer organization
     * @param {Number} customerOrganizationId customer organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteCustomerOrganizationWithHttpInfo = function(customerOrganizationId) {
      var postBody = null;

      // verify the required parameter 'customerOrganizationId' is set
      if (customerOrganizationId === undefined || customerOrganizationId === null) {
        throw new Error("Missing the required parameter 'customerOrganizationId' when calling deleteCustomerOrganization");
      }


      var pathParams = {
        'customerOrganizationId': customerOrganizationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/customerOrganizations/{customerOrganizationId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete customer organization
     * deletes single customer organization
     * @param {Number} customerOrganizationId customer organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteCustomerOrganization = function(customerOrganizationId) {
      return this.deleteCustomerOrganizationWithHttpInfo(customerOrganizationId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find customer organization
     * Returns single customer organization
     * @param {Number} customerOrganizationId customer organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CustomerOrganization} and HTTP response
     */
    this.findCustomerOrganizationWithHttpInfo = function(customerOrganizationId) {
      var postBody = null;

      // verify the required parameter 'customerOrganizationId' is set
      if (customerOrganizationId === undefined || customerOrganizationId === null) {
        throw new Error("Missing the required parameter 'customerOrganizationId' when calling findCustomerOrganization");
      }


      var pathParams = {
        'customerOrganizationId': customerOrganizationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = CustomerOrganization;

      return this.apiClient.callApi(
        '/customerOrganizations/{customerOrganizationId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find customer organization
     * Returns single customer organization
     * @param {Number} customerOrganizationId customer organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CustomerOrganization}
     */
    this.findCustomerOrganization = function(customerOrganizationId) {
      return this.findCustomerOrganizationWithHttpInfo(customerOrganizationId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List customerOrganizations
     * list customer organizations
     * @param {Object} opts Optional parameters
     * @param {String} opts.type filter by customer organization type, one of CUSTOMER, SUPPLIER
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/CustomerOrganization>} and HTTP response
     */
    this.listCustomerOrganizationsWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'type': opts['type'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [CustomerOrganization];

      return this.apiClient.callApi(
        '/customerOrganizations', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List customerOrganizations
     * list customer organizations
     * @param {Object} opts Optional parameters
     * @param {String} opts.type filter by customer organization type, one of CUSTOMER, SUPPLIER
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/CustomerOrganization>}
     */
    this.listCustomerOrganizations = function(opts) {
      return this.listCustomerOrganizationsWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update customer organization
     * Updates a customer organization
     * @param {Number} customerOrganizationId customer organization id
     * @param {module:model/CustomerOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CustomerOrganization} and HTTP response
     */
    this.updateCustomerOrganizationWithHttpInfo = function(customerOrganizationId, body) {
      var postBody = body;

      // verify the required parameter 'customerOrganizationId' is set
      if (customerOrganizationId === undefined || customerOrganizationId === null) {
        throw new Error("Missing the required parameter 'customerOrganizationId' when calling updateCustomerOrganization");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateCustomerOrganization");
      }


      var pathParams = {
        'customerOrganizationId': customerOrganizationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = CustomerOrganization;

      return this.apiClient.callApi(
        '/customerOrganizations/{customerOrganizationId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update customer organization
     * Updates a customer organization
     * @param {Number} customerOrganizationId customer organization id
     * @param {module:model/CustomerOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CustomerOrganization}
     */
    this.updateCustomerOrganization = function(customerOrganizationId, body) {
      return this.updateCustomerOrganizationWithHttpInfo(customerOrganizationId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
