/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/CustomerRepresentative', 'model/Forbidden', 'model/InternalServerError'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/CustomerRepresentative'), require('../model/Forbidden'), require('../model/InternalServerError'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.CustomerRepresentativeApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.CustomerRepresentative, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError);
  }
}(this, function(ApiClient, BadRequest, CustomerRepresentative, Forbidden, InternalServerError) {
  'use strict';

  /**
   * CustomerRepresentative service.
   * @module api/CustomerRepresentativeApi
   * @version 0.0.83
   */

  /**
   * Constructs a new CustomerRepresentativeApi. 
   * @alias module:api/CustomerRepresentativeApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create customer representative
     * Creates new customer representative
     * @param {module:model/CustomerRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CustomerRepresentative} and HTTP response
     */
    this.createCustomerRepresentativeWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createCustomerRepresentative");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = CustomerRepresentative;

      return this.apiClient.callApi(
        '/customerRepresentatives', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create customer representative
     * Creates new customer representative
     * @param {module:model/CustomerRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CustomerRepresentative}
     */
    this.createCustomerRepresentative = function(body) {
      return this.createCustomerRepresentativeWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete customer representative
     * deletes single customer representative
     * @param {Number} customerRepresentativeId customer representative id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteCustomerRepresentativeWithHttpInfo = function(customerRepresentativeId) {
      var postBody = null;

      // verify the required parameter 'customerRepresentativeId' is set
      if (customerRepresentativeId === undefined || customerRepresentativeId === null) {
        throw new Error("Missing the required parameter 'customerRepresentativeId' when calling deleteCustomerRepresentative");
      }


      var pathParams = {
        'customerRepresentativeId': customerRepresentativeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/customerRepresentatives/{customerRepresentativeId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete customer representative
     * deletes single customer representative
     * @param {Number} customerRepresentativeId customer representative id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteCustomerRepresentative = function(customerRepresentativeId) {
      return this.deleteCustomerRepresentativeWithHttpInfo(customerRepresentativeId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find customer representative
     * Returns single customer representative
     * @param {Number} customerRepresentativeId customer representative id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CustomerRepresentative} and HTTP response
     */
    this.findCustomerRepresentativeWithHttpInfo = function(customerRepresentativeId) {
      var postBody = null;

      // verify the required parameter 'customerRepresentativeId' is set
      if (customerRepresentativeId === undefined || customerRepresentativeId === null) {
        throw new Error("Missing the required parameter 'customerRepresentativeId' when calling findCustomerRepresentative");
      }


      var pathParams = {
        'customerRepresentativeId': customerRepresentativeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = CustomerRepresentative;

      return this.apiClient.callApi(
        '/customerRepresentatives/{customerRepresentativeId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find customer representative
     * Returns single customer representative
     * @param {Number} customerRepresentativeId customer representative id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CustomerRepresentative}
     */
    this.findCustomerRepresentative = function(customerRepresentativeId) {
      return this.findCustomerRepresentativeWithHttpInfo(customerRepresentativeId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List customer representatives
     * list customer representatives
     * @param {Object} opts Optional parameters
     * @param {Number} opts.customerOrganizationId filter by customer organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/CustomerRepresentative>} and HTTP response
     */
    this.listCustomerRepresentativesWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'customerOrganizationId': opts['customerOrganizationId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [CustomerRepresentative];

      return this.apiClient.callApi(
        '/customerRepresentatives', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List customer representatives
     * list customer representatives
     * @param {Object} opts Optional parameters
     * @param {Number} opts.customerOrganizationId filter by customer organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/CustomerRepresentative>}
     */
    this.listCustomerRepresentatives = function(opts) {
      return this.listCustomerRepresentativesWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update customer representative
     * Updates a customer representative
     * @param {Number} customerRepresentativeId customer representative id
     * @param {module:model/CustomerRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/CustomerRepresentative} and HTTP response
     */
    this.updateCustomerRepresentativeWithHttpInfo = function(customerRepresentativeId, body) {
      var postBody = body;

      // verify the required parameter 'customerRepresentativeId' is set
      if (customerRepresentativeId === undefined || customerRepresentativeId === null) {
        throw new Error("Missing the required parameter 'customerRepresentativeId' when calling updateCustomerRepresentative");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateCustomerRepresentative");
      }


      var pathParams = {
        'customerRepresentativeId': customerRepresentativeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = CustomerRepresentative;

      return this.apiClient.callApi(
        '/customerRepresentatives/{customerRepresentativeId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update customer representative
     * Updates a customer representative
     * @param {Number} customerRepresentativeId customer representative id
     * @param {module:model/CustomerRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/CustomerRepresentative}
     */
    this.updateCustomerRepresentative = function(customerRepresentativeId, body) {
      return this.updateCustomerRepresentativeWithHttpInfo(customerRepresentativeId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
