/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalOrder', 'model/InternalServerError'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalOrder'), require('../model/InternalServerError'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.InternalOrderApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalOrder, root.KykyapiClient.InternalServerError);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalOrder, InternalServerError) {
  'use strict';

  /**
   * InternalOrder service.
   * @module api/InternalOrderApi
   * @version 0.0.83
   */

  /**
   * Constructs a new InternalOrderApi. 
   * @alias module:api/InternalOrderApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create internal order
     * Creates new internal order
     * @param {module:model/InternalOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/InternalOrder} and HTTP response
     */
    this.createInternalOrderWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createInternalOrder");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = InternalOrder;

      return this.apiClient.callApi(
        '/internalOrders', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create internal order
     * Creates new internal order
     * @param {module:model/InternalOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/InternalOrder}
     */
    this.createInternalOrder = function(body) {
      return this.createInternalOrderWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete internal order
     * deletets single internal order
     * @param {Number} internalOrderId internal order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteInternalOrderWithHttpInfo = function(internalOrderId) {
      var postBody = null;

      // verify the required parameter 'internalOrderId' is set
      if (internalOrderId === undefined || internalOrderId === null) {
        throw new Error("Missing the required parameter 'internalOrderId' when calling deleteInternalOrder");
      }


      var pathParams = {
        'internalOrderId': internalOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/internalOrders/{internalOrderId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete internal order
     * deletets single internal order
     * @param {Number} internalOrderId internal order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteInternalOrder = function(internalOrderId) {
      return this.deleteInternalOrderWithHttpInfo(internalOrderId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find internal order
     * Returns single internal order
     * @param {Number} internalOrderId internal order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/InternalOrder} and HTTP response
     */
    this.findInternalOrderWithHttpInfo = function(internalOrderId) {
      var postBody = null;

      // verify the required parameter 'internalOrderId' is set
      if (internalOrderId === undefined || internalOrderId === null) {
        throw new Error("Missing the required parameter 'internalOrderId' when calling findInternalOrder");
      }


      var pathParams = {
        'internalOrderId': internalOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = InternalOrder;

      return this.apiClient.callApi(
        '/internalOrders/{internalOrderId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find internal order
     * Returns single internal order
     * @param {Number} internalOrderId internal order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/InternalOrder}
     */
    this.findInternalOrder = function(internalOrderId) {
      return this.findInternalOrderWithHttpInfo(internalOrderId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List internal orders
     * List internal orders
     * @param {Number} saleId filter by sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/InternalOrder>} and HTTP response
     */
    this.listInternalOrdersWithHttpInfo = function(saleId) {
      var postBody = null;

      // verify the required parameter 'saleId' is set
      if (saleId === undefined || saleId === null) {
        throw new Error("Missing the required parameter 'saleId' when calling listInternalOrders");
      }


      var pathParams = {
      };
      var queryParams = {
        'saleId': saleId,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [InternalOrder];

      return this.apiClient.callApi(
        '/internalOrders', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List internal orders
     * List internal orders
     * @param {Number} saleId filter by sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/InternalOrder>}
     */
    this.listInternalOrders = function(saleId) {
      return this.listInternalOrdersWithHttpInfo(saleId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update internal order
     * Updates a internal order
     * @param {Number} internalOrderId sale order id
     * @param {module:model/InternalOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/InternalOrder} and HTTP response
     */
    this.updateInternalOrderWithHttpInfo = function(internalOrderId, body) {
      var postBody = body;

      // verify the required parameter 'internalOrderId' is set
      if (internalOrderId === undefined || internalOrderId === null) {
        throw new Error("Missing the required parameter 'internalOrderId' when calling updateInternalOrder");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateInternalOrder");
      }


      var pathParams = {
        'internalOrderId': internalOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = InternalOrder;

      return this.apiClient.callApi(
        '/internalOrders/{internalOrderId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update internal order
     * Updates a internal order
     * @param {Number} internalOrderId sale order id
     * @param {module:model/InternalOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/InternalOrder}
     */
    this.updateInternalOrder = function(internalOrderId, body) {
      return this.updateInternalOrderWithHttpInfo(internalOrderId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
