/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/ListProduct'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/ListProduct'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.ListProductApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.ListProduct);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, ListProduct) {
  'use strict';

  /**
   * ListProduct service.
   * @module api/ListProductApi
   * @version 0.0.83
   */

  /**
   * Constructs a new ListProductApi. 
   * @alias module:api/ListProductApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create list product
     * Create list list product
     * @param {module:model/ListProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ListProduct} and HTTP response
     */
    this.createListProductWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createListProduct");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = ListProduct;

      return this.apiClient.callApi(
        '/listProducts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create list product
     * Create list list product
     * @param {module:model/ListProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ListProduct}
     */
    this.createListProduct = function(body) {
      return this.createListProductWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete a list product
     * Deletes single list product
     * @param {Number} listProductId list product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteListProductWithHttpInfo = function(listProductId) {
      var postBody = null;

      // verify the required parameter 'listProductId' is set
      if (listProductId === undefined || listProductId === null) {
        throw new Error("Missing the required parameter 'listProductId' when calling deleteListProduct");
      }


      var pathParams = {
        'listProductId': listProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/listProducts/{listProductId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete a list product
     * Deletes single list product
     * @param {Number} listProductId list product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteListProduct = function(listProductId) {
      return this.deleteListProductWithHttpInfo(listProductId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find a list product
     * Returns single list product
     * @param {Number} listProductId list product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ListProduct} and HTTP response
     */
    this.findListProductWithHttpInfo = function(listProductId) {
      var postBody = null;

      // verify the required parameter 'listProductId' is set
      if (listProductId === undefined || listProductId === null) {
        throw new Error("Missing the required parameter 'listProductId' when calling findListProduct");
      }


      var pathParams = {
        'listProductId': listProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = ListProduct;

      return this.apiClient.callApi(
        '/listProducts/{listProductId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find a list product
     * Returns single list product
     * @param {Number} listProductId list product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ListProduct}
     */
    this.findListProduct = function(listProductId) {
      return this.findListProductWithHttpInfo(listProductId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List list products
     * list list products
     * @param {Object} opts Optional parameters
     * @param {String} opts.category Filter results by category
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/ListProduct>} and HTTP response
     */
    this.listListProductsWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'category': opts['category'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [ListProduct];

      return this.apiClient.callApi(
        '/listProducts', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List list products
     * list list products
     * @param {Object} opts Optional parameters
     * @param {String} opts.category Filter results by category
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/ListProduct>}
     */
    this.listListProducts = function(opts) {
      return this.listListProductsWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update list product
     * Updates a list product
     * @param {Number} listProductId list product id
     * @param {module:model/ListProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/ListProduct} and HTTP response
     */
    this.updateListProductWithHttpInfo = function(listProductId, body) {
      var postBody = body;

      // verify the required parameter 'listProductId' is set
      if (listProductId === undefined || listProductId === null) {
        throw new Error("Missing the required parameter 'listProductId' when calling updateListProduct");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateListProduct");
      }


      var pathParams = {
        'listProductId': listProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = ListProduct;

      return this.apiClient.callApi(
        '/listProducts/{listProductId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update list product
     * Updates a list product
     * @param {Number} listProductId list product id
     * @param {module:model/ListProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/ListProduct}
     */
    this.updateListProduct = function(listProductId, body) {
      return this.updateListProductWithHttpInfo(listProductId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
