/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/PurchaseOfferRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/PurchaseOfferRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.PurchaseOfferRequestApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.PurchaseOfferRequest);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, PurchaseOfferRequest) {
  'use strict';

  /**
   * PurchaseOfferRequest service.
   * @module api/PurchaseOfferRequestApi
   * @version 0.0.83
   */

  /**
   * Constructs a new PurchaseOfferRequestApi. 
   * @alias module:api/PurchaseOfferRequestApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create purchase offer request
     * Create purchase offer request
     * @param {module:model/PurchaseOfferRequest} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PurchaseOfferRequest} and HTTP response
     */
    this.createPurchaseOfferRequestWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createPurchaseOfferRequest");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = PurchaseOfferRequest;

      return this.apiClient.callApi(
        '/purchaseOfferRequests', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create purchase offer request
     * Create purchase offer request
     * @param {module:model/PurchaseOfferRequest} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PurchaseOfferRequest}
     */
    this.createPurchaseOfferRequest = function(body) {
      return this.createPurchaseOfferRequestWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete purchase offer request
     * Delete purchase offer request
     * @param {Number} purchaseOfferRequestId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deletePurchaseOfferRequestWithHttpInfo = function(purchaseOfferRequestId) {
      var postBody = null;

      // verify the required parameter 'purchaseOfferRequestId' is set
      if (purchaseOfferRequestId === undefined || purchaseOfferRequestId === null) {
        throw new Error("Missing the required parameter 'purchaseOfferRequestId' when calling deletePurchaseOfferRequest");
      }


      var pathParams = {
        'purchaseOfferRequestId': purchaseOfferRequestId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/purchaseOfferRequests/{purchaseOfferRequestId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete purchase offer request
     * Delete purchase offer request
     * @param {Number} purchaseOfferRequestId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deletePurchaseOfferRequest = function(purchaseOfferRequestId) {
      return this.deletePurchaseOfferRequestWithHttpInfo(purchaseOfferRequestId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find purchase offer request
     * Find purchase offer request
     * @param {Number} purchaseOfferRequestId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PurchaseOfferRequest} and HTTP response
     */
    this.findPurchaseOfferRequestWithHttpInfo = function(purchaseOfferRequestId) {
      var postBody = null;

      // verify the required parameter 'purchaseOfferRequestId' is set
      if (purchaseOfferRequestId === undefined || purchaseOfferRequestId === null) {
        throw new Error("Missing the required parameter 'purchaseOfferRequestId' when calling findPurchaseOfferRequest");
      }


      var pathParams = {
        'purchaseOfferRequestId': purchaseOfferRequestId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = PurchaseOfferRequest;

      return this.apiClient.callApi(
        '/purchaseOfferRequests/{purchaseOfferRequestId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find purchase offer request
     * Find purchase offer request
     * @param {Number} purchaseOfferRequestId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PurchaseOfferRequest}
     */
    this.findPurchaseOfferRequest = function(purchaseOfferRequestId) {
      return this.findPurchaseOfferRequestWithHttpInfo(purchaseOfferRequestId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Get purchase offer request PDF
     * Returns purchase offer request PDF
     * @param {Number} purchaseOfferRequestId purchase offer request id
     * @param {String} type Specifies returned PDF type. One of PURCHASE_OFFER_REQUEST
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link 'Blob'} and HTTP response
     */
    this.getPurchaseOfferRequestsPdfWithHttpInfo = function(purchaseOfferRequestId, type) {
      var postBody = null;

      // verify the required parameter 'purchaseOfferRequestId' is set
      if (purchaseOfferRequestId === undefined || purchaseOfferRequestId === null) {
        throw new Error("Missing the required parameter 'purchaseOfferRequestId' when calling getPurchaseOfferRequestsPdf");
      }

      // verify the required parameter 'type' is set
      if (type === undefined || type === null) {
        throw new Error("Missing the required parameter 'type' when calling getPurchaseOfferRequestsPdf");
      }


      var pathParams = {
        'purchaseOfferRequestId': purchaseOfferRequestId
      };
      var queryParams = {
        'type': type,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = 'Blob';

      return this.apiClient.callApi(
        '/purchaseOfferRequests/{purchaseOfferRequestId}/pdf', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Get purchase offer request PDF
     * Returns purchase offer request PDF
     * @param {Number} purchaseOfferRequestId purchase offer request id
     * @param {String} type Specifies returned PDF type. One of PURCHASE_OFFER_REQUEST
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link 'Blob'}
     */
    this.getPurchaseOfferRequestsPdf = function(purchaseOfferRequestId, type) {
      return this.getPurchaseOfferRequestsPdfWithHttpInfo(purchaseOfferRequestId, type)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List purchase offer requests
     * List purchase offer requests
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter purchase offer requests by sale id
     * @param {Number} opts.firstResult start from result
     * @param {Number} opts.maxResults limit with max results
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/PurchaseOfferRequest>} and HTTP response
     */
    this.listPurchaseOfferRequestsWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'saleId': opts['saleId'],
        'firstResult': opts['firstResult'],
        'maxResults': opts['maxResults'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [PurchaseOfferRequest];

      return this.apiClient.callApi(
        '/purchaseOfferRequests', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List purchase offer requests
     * List purchase offer requests
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter purchase offer requests by sale id
     * @param {Number} opts.firstResult start from result
     * @param {Number} opts.maxResults limit with max results
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/PurchaseOfferRequest>}
     */
    this.listPurchaseOfferRequests = function(opts) {
      return this.listPurchaseOfferRequestsWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update purchase offer request
     * Update purchase offer request
     * @param {Number} purchaseOfferRequestId sale order id
     * @param {module:model/PurchaseOfferRequest} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PurchaseOfferRequest} and HTTP response
     */
    this.updatePurchaseOfferRequestWithHttpInfo = function(purchaseOfferRequestId, body) {
      var postBody = body;

      // verify the required parameter 'purchaseOfferRequestId' is set
      if (purchaseOfferRequestId === undefined || purchaseOfferRequestId === null) {
        throw new Error("Missing the required parameter 'purchaseOfferRequestId' when calling updatePurchaseOfferRequest");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updatePurchaseOfferRequest");
      }


      var pathParams = {
        'purchaseOfferRequestId': purchaseOfferRequestId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = PurchaseOfferRequest;

      return this.apiClient.callApi(
        '/purchaseOfferRequests/{purchaseOfferRequestId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update purchase offer request
     * Update purchase offer request
     * @param {Number} purchaseOfferRequestId sale order id
     * @param {module:model/PurchaseOfferRequest} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PurchaseOfferRequest}
     */
    this.updatePurchaseOfferRequest = function(purchaseOfferRequestId, body) {
      return this.updatePurchaseOfferRequestWithHttpInfo(purchaseOfferRequestId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
