/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/PurchaseOrder'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/PurchaseOrder'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.PurchaseOrderApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.PurchaseOrder);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, PurchaseOrder) {
  'use strict';

  /**
   * PurchaseOrder service.
   * @module api/PurchaseOrderApi
   * @version 0.0.83
   */

  /**
   * Constructs a new PurchaseOrderApi. 
   * @alias module:api/PurchaseOrderApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create purchase order
     * Create purchase order
     * @param {module:model/PurchaseOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PurchaseOrder} and HTTP response
     */
    this.createPurchaseOrderWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createPurchaseOrder");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = PurchaseOrder;

      return this.apiClient.callApi(
        '/purchaseOrders', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create purchase order
     * Create purchase order
     * @param {module:model/PurchaseOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PurchaseOrder}
     */
    this.createPurchaseOrder = function(body) {
      return this.createPurchaseOrderWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete purchase order
     * Deletes single purchase order
     * @param {Number} purchaseOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deletePurchaseOrderWithHttpInfo = function(purchaseOrderId) {
      var postBody = null;

      // verify the required parameter 'purchaseOrderId' is set
      if (purchaseOrderId === undefined || purchaseOrderId === null) {
        throw new Error("Missing the required parameter 'purchaseOrderId' when calling deletePurchaseOrder");
      }


      var pathParams = {
        'purchaseOrderId': purchaseOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/purchaseOrders/{purchaseOrderId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete purchase order
     * Deletes single purchase order
     * @param {Number} purchaseOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deletePurchaseOrder = function(purchaseOrderId) {
      return this.deletePurchaseOrderWithHttpInfo(purchaseOrderId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find purchase order
     * Returns single purchase order
     * @param {Number} purchaseOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PurchaseOrder} and HTTP response
     */
    this.findPurchaseOrderWithHttpInfo = function(purchaseOrderId) {
      var postBody = null;

      // verify the required parameter 'purchaseOrderId' is set
      if (purchaseOrderId === undefined || purchaseOrderId === null) {
        throw new Error("Missing the required parameter 'purchaseOrderId' when calling findPurchaseOrder");
      }


      var pathParams = {
        'purchaseOrderId': purchaseOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = PurchaseOrder;

      return this.apiClient.callApi(
        '/purchaseOrders/{purchaseOrderId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find purchase order
     * Returns single purchase order
     * @param {Number} purchaseOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PurchaseOrder}
     */
    this.findPurchaseOrder = function(purchaseOrderId) {
      return this.findPurchaseOrderWithHttpInfo(purchaseOrderId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Get purchase order PDF
     * Returns purchase order PDF
     * @param {Number} purchaseOrderId purchase order id
     * @param {String} type Specifies returned PDF type. One of PURCHASE_ORDER
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link 'Blob'} and HTTP response
     */
    this.getPurchaseOrderPdfWithHttpInfo = function(purchaseOrderId, type) {
      var postBody = null;

      // verify the required parameter 'purchaseOrderId' is set
      if (purchaseOrderId === undefined || purchaseOrderId === null) {
        throw new Error("Missing the required parameter 'purchaseOrderId' when calling getPurchaseOrderPdf");
      }

      // verify the required parameter 'type' is set
      if (type === undefined || type === null) {
        throw new Error("Missing the required parameter 'type' when calling getPurchaseOrderPdf");
      }


      var pathParams = {
        'purchaseOrderId': purchaseOrderId
      };
      var queryParams = {
        'type': type,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = 'Blob';

      return this.apiClient.callApi(
        '/purchaseOrders/{purchaseOrderId}/pdf', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Get purchase order PDF
     * Returns purchase order PDF
     * @param {Number} purchaseOrderId purchase order id
     * @param {String} type Specifies returned PDF type. One of PURCHASE_ORDER
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link 'Blob'}
     */
    this.getPurchaseOrderPdf = function(purchaseOrderId, type) {
      return this.getPurchaseOrderPdfWithHttpInfo(purchaseOrderId, type)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List purchase orders
     * List purchase orders
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter by sale id
     * @param {String} opts.estimatedArrivalTimeBefore return only purchase orders that have estimated arrival time after the date
     * @param {String} opts.estimatedArrivalTimeAfter return only purchase orders that have estimated arrival time after the date
     * @param {String} opts.state return only purchase orders that have specified state
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/PurchaseOrder>} and HTTP response
     */
    this.listPurchaseOrdersWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'saleId': opts['saleId'],
        'estimatedArrivalTimeBefore': opts['estimatedArrivalTimeBefore'],
        'estimatedArrivalTimeAfter': opts['estimatedArrivalTimeAfter'],
        'state': opts['state'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [PurchaseOrder];

      return this.apiClient.callApi(
        '/purchaseOrders', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List purchase orders
     * List purchase orders
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter by sale id
     * @param {String} opts.estimatedArrivalTimeBefore return only purchase orders that have estimated arrival time after the date
     * @param {String} opts.estimatedArrivalTimeAfter return only purchase orders that have estimated arrival time after the date
     * @param {String} opts.state return only purchase orders that have specified state
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/PurchaseOrder>}
     */
    this.listPurchaseOrders = function(opts) {
      return this.listPurchaseOrdersWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update purchase order
     * Updates a purchase order
     * @param {Number} purchaseOrderId sale order id
     * @param {module:model/PurchaseOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PurchaseOrder} and HTTP response
     */
    this.updatePurchaseOrderWithHttpInfo = function(purchaseOrderId, body) {
      var postBody = body;

      // verify the required parameter 'purchaseOrderId' is set
      if (purchaseOrderId === undefined || purchaseOrderId === null) {
        throw new Error("Missing the required parameter 'purchaseOrderId' when calling updatePurchaseOrder");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updatePurchaseOrder");
      }


      var pathParams = {
        'purchaseOrderId': purchaseOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = PurchaseOrder;

      return this.apiClient.callApi(
        '/purchaseOrders/{purchaseOrderId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update purchase order
     * Updates a purchase order
     * @param {Number} purchaseOrderId sale order id
     * @param {module:model/PurchaseOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PurchaseOrder}
     */
    this.updatePurchaseOrder = function(purchaseOrderId, body) {
      return this.updatePurchaseOrderWithHttpInfo(purchaseOrderId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
