/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/RowProduct'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/RowProduct'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.RowProductApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.RowProduct);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, RowProduct) {
  'use strict';

  /**
   * RowProduct service.
   * @module api/RowProductApi
   * @version 0.0.83
   */

  /**
   * Constructs a new RowProductApi. 
   * @alias module:api/RowProductApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create row product
     * Creates new row product
     * @param {module:model/RowProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/RowProduct} and HTTP response
     */
    this.createRowProductWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createRowProduct");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = RowProduct;

      return this.apiClient.callApi(
        '/rowProducts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create row product
     * Creates new row product
     * @param {module:model/RowProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/RowProduct}
     */
    this.createRowProduct = function(body) {
      return this.createRowProductWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete row product
     * Deletes a row product
     * @param {Number} rowProductId row product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteRowProductWithHttpInfo = function(rowProductId) {
      var postBody = null;

      // verify the required parameter 'rowProductId' is set
      if (rowProductId === undefined || rowProductId === null) {
        throw new Error("Missing the required parameter 'rowProductId' when calling deleteRowProduct");
      }


      var pathParams = {
        'rowProductId': rowProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/rowProducts/{rowProductId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete row product
     * Deletes a row product
     * @param {Number} rowProductId row product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteRowProduct = function(rowProductId) {
      return this.deleteRowProductWithHttpInfo(rowProductId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find row product
     * Returns single row product
     * @param {Number} rowProductId row product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/RowProduct} and HTTP response
     */
    this.findRowProductWithHttpInfo = function(rowProductId) {
      var postBody = null;

      // verify the required parameter 'rowProductId' is set
      if (rowProductId === undefined || rowProductId === null) {
        throw new Error("Missing the required parameter 'rowProductId' when calling findRowProduct");
      }


      var pathParams = {
        'rowProductId': rowProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = RowProduct;

      return this.apiClient.callApi(
        '/rowProducts/{rowProductId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find row product
     * Returns single row product
     * @param {Number} rowProductId row product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/RowProduct}
     */
    this.findRowProduct = function(rowProductId) {
      return this.findRowProductWithHttpInfo(rowProductId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List row products
     * Returns list of row products
     * @param {Number} parentId parent id of row product
     * @param {String} parentType parent type of row product
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/RowProduct>} and HTTP response
     */
    this.listRowProductsWithHttpInfo = function(parentId, parentType) {
      var postBody = null;

      // verify the required parameter 'parentId' is set
      if (parentId === undefined || parentId === null) {
        throw new Error("Missing the required parameter 'parentId' when calling listRowProducts");
      }

      // verify the required parameter 'parentType' is set
      if (parentType === undefined || parentType === null) {
        throw new Error("Missing the required parameter 'parentType' when calling listRowProducts");
      }


      var pathParams = {
      };
      var queryParams = {
        'parentId': parentId,
        'parentType': parentType,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [RowProduct];

      return this.apiClient.callApi(
        '/rowProducts', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List row products
     * Returns list of row products
     * @param {Number} parentId parent id of row product
     * @param {String} parentType parent type of row product
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/RowProduct>}
     */
    this.listRowProducts = function(parentId, parentType) {
      return this.listRowProductsWithHttpInfo(parentId, parentType)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update row product
     * Updates a row product
     * @param {Number} rowProductId row product id
     * @param {module:model/RowProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/RowProduct} and HTTP response
     */
    this.updateRowProductWithHttpInfo = function(rowProductId, body) {
      var postBody = body;

      // verify the required parameter 'rowProductId' is set
      if (rowProductId === undefined || rowProductId === null) {
        throw new Error("Missing the required parameter 'rowProductId' when calling updateRowProduct");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateRowProduct");
      }


      var pathParams = {
        'rowProductId': rowProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = RowProduct;

      return this.apiClient.callApi(
        '/rowProducts/{rowProductId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update row product
     * Updates a row product
     * @param {Number} rowProductId row product id
     * @param {module:model/RowProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/RowProduct}
     */
    this.updateRowProduct = function(rowProductId, body) {
      return this.updateRowProductWithHttpInfo(rowProductId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
