/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/Sale'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/Sale'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SaleApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.Sale);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, Sale) {
  'use strict';

  /**
   * Sale service.
   * @module api/SaleApi
   * @version 0.0.83
   */

  /**
   * Constructs a new SaleApi. 
   * @alias module:api/SaleApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create sale
     * Creates new sale
     * @param {module:model/Sale} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Sale} and HTTP response
     */
    this.createSaleWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createSale");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Sale;

      return this.apiClient.callApi(
        '/sales', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create sale
     * Creates new sale
     * @param {module:model/Sale} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Sale}
     */
    this.createSale = function(body) {
      return this.createSaleWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete sale
     * Deletes sale
     * @param {Number} saleId sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteSaleWithHttpInfo = function(saleId) {
      var postBody = null;

      // verify the required parameter 'saleId' is set
      if (saleId === undefined || saleId === null) {
        throw new Error("Missing the required parameter 'saleId' when calling deleteSale");
      }


      var pathParams = {
        'saleId': saleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/sales/{saleId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete sale
     * Deletes sale
     * @param {Number} saleId sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteSale = function(saleId) {
      return this.deleteSaleWithHttpInfo(saleId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find sale
     * Returns single sale
     * @param {Number} saleId sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Sale} and HTTP response
     */
    this.findSaleWithHttpInfo = function(saleId) {
      var postBody = null;

      // verify the required parameter 'saleId' is set
      if (saleId === undefined || saleId === null) {
        throw new Error("Missing the required parameter 'saleId' when calling findSale");
      }


      var pathParams = {
        'saleId': saleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Sale;

      return this.apiClient.callApi(
        '/sales/{saleId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find sale
     * Returns single sale
     * @param {Number} saleId sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Sale}
     */
    this.findSale = function(saleId) {
      return this.findSaleWithHttpInfo(saleId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List sales
     * List sales
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.archived list only archived sales
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/Sale>} and HTTP response
     */
    this.listSalesWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'archived': opts['archived'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [Sale];

      return this.apiClient.callApi(
        '/sales', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List sales
     * List sales
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.archived list only archived sales
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/Sale>}
     */
    this.listSales = function(opts) {
      return this.listSalesWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update sale
     * Updates a sale
     * @param {Number} saleId sale id
     * @param {module:model/Sale} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Sale} and HTTP response
     */
    this.updateSaleWithHttpInfo = function(saleId, body) {
      var postBody = body;

      // verify the required parameter 'saleId' is set
      if (saleId === undefined || saleId === null) {
        throw new Error("Missing the required parameter 'saleId' when calling updateSale");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSale");
      }


      var pathParams = {
        'saleId': saleId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Sale;

      return this.apiClient.callApi(
        '/sales/{saleId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update sale
     * Updates a sale
     * @param {Number} saleId sale id
     * @param {module:model/Sale} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Sale}
     */
    this.updateSale = function(saleId, body) {
      return this.updateSaleWithHttpInfo(saleId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
