/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/SaleOffer'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/SaleOffer'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SaleOfferApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.SaleOffer);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, SaleOffer) {
  'use strict';

  /**
   * SaleOffer service.
   * @module api/SaleOfferApi
   * @version 0.0.83
   */

  /**
   * Constructs a new SaleOfferApi. 
   * @alias module:api/SaleOfferApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create sale offer
     * Creates new sale offer
     * @param {module:model/SaleOffer} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SaleOffer} and HTTP response
     */
    this.createSaleOfferWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createSaleOffer");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SaleOffer;

      return this.apiClient.callApi(
        '/saleOffers', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create sale offer
     * Creates new sale offer
     * @param {module:model/SaleOffer} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SaleOffer}
     */
    this.createSaleOffer = function(body) {
      return this.createSaleOfferWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete sale offer
     * Deletes single sale offer
     * @param {Number} saleOfferId sale offer id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteSaleOfferWithHttpInfo = function(saleOfferId) {
      var postBody = null;

      // verify the required parameter 'saleOfferId' is set
      if (saleOfferId === undefined || saleOfferId === null) {
        throw new Error("Missing the required parameter 'saleOfferId' when calling deleteSaleOffer");
      }


      var pathParams = {
        'saleOfferId': saleOfferId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/saleOffers/{saleOfferId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete sale offer
     * Deletes single sale offer
     * @param {Number} saleOfferId sale offer id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteSaleOffer = function(saleOfferId) {
      return this.deleteSaleOfferWithHttpInfo(saleOfferId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find sale offer
     * Returns single sale offer
     * @param {Number} saleOfferId sale offer id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SaleOffer} and HTTP response
     */
    this.findSaleOfferWithHttpInfo = function(saleOfferId) {
      var postBody = null;

      // verify the required parameter 'saleOfferId' is set
      if (saleOfferId === undefined || saleOfferId === null) {
        throw new Error("Missing the required parameter 'saleOfferId' when calling findSaleOffer");
      }


      var pathParams = {
        'saleOfferId': saleOfferId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SaleOffer;

      return this.apiClient.callApi(
        '/saleOffers/{saleOfferId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find sale offer
     * Returns single sale offer
     * @param {Number} saleOfferId sale offer id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SaleOffer}
     */
    this.findSaleOffer = function(saleOfferId) {
      return this.findSaleOfferWithHttpInfo(saleOfferId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Get sale offer PDF
     * Returns sale offer PDF
     * @param {Number} saleOfferId sale offer id
     * @param {String} type Specifies returned PDF type. One of SALE_OFFER
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link 'Blob'} and HTTP response
     */
    this.getSaleOfferPdfWithHttpInfo = function(saleOfferId, type) {
      var postBody = null;

      // verify the required parameter 'saleOfferId' is set
      if (saleOfferId === undefined || saleOfferId === null) {
        throw new Error("Missing the required parameter 'saleOfferId' when calling getSaleOfferPdf");
      }

      // verify the required parameter 'type' is set
      if (type === undefined || type === null) {
        throw new Error("Missing the required parameter 'type' when calling getSaleOfferPdf");
      }


      var pathParams = {
        'saleOfferId': saleOfferId
      };
      var queryParams = {
        'type': type,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = 'Blob';

      return this.apiClient.callApi(
        '/saleOffers/{saleOfferId}/pdf', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Get sale offer PDF
     * Returns sale offer PDF
     * @param {Number} saleOfferId sale offer id
     * @param {String} type Specifies returned PDF type. One of SALE_OFFER
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link 'Blob'}
     */
    this.getSaleOfferPdf = function(saleOfferId, type) {
      return this.getSaleOfferPdfWithHttpInfo(saleOfferId, type)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List sale offers
     * List sale offers
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter sale offerts by sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/SaleOffer>} and HTTP response
     */
    this.listSaleOffersWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'saleId': opts['saleId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [SaleOffer];

      return this.apiClient.callApi(
        '/saleOffers', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List sale offers
     * List sale offers
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter sale offerts by sale id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/SaleOffer>}
     */
    this.listSaleOffers = function(opts) {
      return this.listSaleOffersWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update sale offer
     * Updates a sale offer
     * @param {Number} saleOfferId sale offer id
     * @param {module:model/SaleOffer} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SaleOffer} and HTTP response
     */
    this.updateSaleOfferWithHttpInfo = function(saleOfferId, body) {
      var postBody = body;

      // verify the required parameter 'saleOfferId' is set
      if (saleOfferId === undefined || saleOfferId === null) {
        throw new Error("Missing the required parameter 'saleOfferId' when calling updateSaleOffer");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSaleOffer");
      }


      var pathParams = {
        'saleOfferId': saleOfferId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SaleOffer;

      return this.apiClient.callApi(
        '/saleOffers/{saleOfferId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update sale offer
     * Updates a sale offer
     * @param {Number} saleOfferId sale offer id
     * @param {module:model/SaleOffer} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SaleOffer}
     */
    this.updateSaleOffer = function(saleOfferId, body) {
      return this.updateSaleOfferWithHttpInfo(saleOfferId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
