/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/SaleOrder'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/SaleOrder'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SaleOrderApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.SaleOrder);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, SaleOrder) {
  'use strict';

  /**
   * SaleOrder service.
   * @module api/SaleOrderApi
   * @version 0.0.83
   */

  /**
   * Constructs a new SaleOrderApi. 
   * @alias module:api/SaleOrderApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create sale order
     * Creates new sale order
     * @param {module:model/SaleOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SaleOrder} and HTTP response
     */
    this.createSaleOrderWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createSaleOrder");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SaleOrder;

      return this.apiClient.callApi(
        '/saleOrders', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create sale order
     * Creates new sale order
     * @param {module:model/SaleOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SaleOrder}
     */
    this.createSaleOrder = function(body) {
      return this.createSaleOrderWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Delete sale order
     * Deletes single sale order
     * @param {Number} saleOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.deleteSaleOrderWithHttpInfo = function(saleOrderId) {
      var postBody = null;

      // verify the required parameter 'saleOrderId' is set
      if (saleOrderId === undefined || saleOrderId === null) {
        throw new Error("Missing the required parameter 'saleOrderId' when calling deleteSaleOrder");
      }


      var pathParams = {
        'saleOrderId': saleOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/saleOrders/{saleOrderId}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Delete sale order
     * Deletes single sale order
     * @param {Number} saleOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.deleteSaleOrder = function(saleOrderId) {
      return this.deleteSaleOrderWithHttpInfo(saleOrderId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find sale order
     * Returns single sale order
     * @param {Number} saleOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SaleOrder} and HTTP response
     */
    this.findSaleOrderWithHttpInfo = function(saleOrderId) {
      var postBody = null;

      // verify the required parameter 'saleOrderId' is set
      if (saleOrderId === undefined || saleOrderId === null) {
        throw new Error("Missing the required parameter 'saleOrderId' when calling findSaleOrder");
      }


      var pathParams = {
        'saleOrderId': saleOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SaleOrder;

      return this.apiClient.callApi(
        '/saleOrders/{saleOrderId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find sale order
     * Returns single sale order
     * @param {Number} saleOrderId sale order id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SaleOrder}
     */
    this.findSaleOrder = function(saleOrderId) {
      return this.findSaleOrderWithHttpInfo(saleOrderId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Get sale order PDF
     * Returns sale order PDF
     * @param {Number} saleOrderId sale order id
     * @param {String} type Specifies returned PDF type. One of ORDER_CONFIRMATION
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link 'Blob'} and HTTP response
     */
    this.getSaleOrderPdfWithHttpInfo = function(saleOrderId, type) {
      var postBody = null;

      // verify the required parameter 'saleOrderId' is set
      if (saleOrderId === undefined || saleOrderId === null) {
        throw new Error("Missing the required parameter 'saleOrderId' when calling getSaleOrderPdf");
      }

      // verify the required parameter 'type' is set
      if (type === undefined || type === null) {
        throw new Error("Missing the required parameter 'type' when calling getSaleOrderPdf");
      }


      var pathParams = {
        'saleOrderId': saleOrderId
      };
      var queryParams = {
        'type': type,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = 'Blob';

      return this.apiClient.callApi(
        '/saleOrders/{saleOrderId}/pdf', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Get sale order PDF
     * Returns sale order PDF
     * @param {Number} saleOrderId sale order id
     * @param {String} type Specifies returned PDF type. One of ORDER_CONFIRMATION
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link 'Blob'}
     */
    this.getSaleOrderPdf = function(saleOrderId, type) {
      return this.getSaleOrderPdfWithHttpInfo(saleOrderId, type)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List sale orders
     * List sale orders
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter by sale id
     * @param {String} opts.deliveryTimeBefore return only saleorders that have delivery time before the date
     * @param {String} opts.deliveryTimeAfter return only saleorders that have delivery time after the date
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/SaleOrder>} and HTTP response
     */
    this.listSaleOrdersWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'saleId': opts['saleId'],
        'deliveryTimeBefore': opts['deliveryTimeBefore'],
        'deliveryTimeAfter': opts['deliveryTimeAfter'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [SaleOrder];

      return this.apiClient.callApi(
        '/saleOrders', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List sale orders
     * List sale orders
     * @param {Object} opts Optional parameters
     * @param {Number} opts.saleId filter by sale id
     * @param {String} opts.deliveryTimeBefore return only saleorders that have delivery time before the date
     * @param {String} opts.deliveryTimeAfter return only saleorders that have delivery time after the date
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/SaleOrder>}
     */
    this.listSaleOrders = function(opts) {
      return this.listSaleOrdersWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update sale order
     * Updates a sale order
     * @param {Number} saleOrderId sale order id
     * @param {module:model/SaleOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SaleOrder} and HTTP response
     */
    this.updateSaleOrderWithHttpInfo = function(saleOrderId, body) {
      var postBody = body;

      // verify the required parameter 'saleOrderId' is set
      if (saleOrderId === undefined || saleOrderId === null) {
        throw new Error("Missing the required parameter 'saleOrderId' when calling updateSaleOrder");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSaleOrder");
      }


      var pathParams = {
        'saleOrderId': saleOrderId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SaleOrder;

      return this.apiClient.callApi(
        '/saleOrders/{saleOrderId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update sale order
     * Updates a sale order
     * @param {Number} saleOrderId sale order id
     * @param {module:model/SaleOrder} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SaleOrder}
     */
    this.updateSaleOrder = function(saleOrderId, body) {
      return this.updateSaleOrderWithHttpInfo(saleOrderId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
