/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/Schematic'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/Schematic'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SchematicApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.Schematic);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, Schematic) {
  'use strict';

  /**
   * Schematic service.
   * @module api/SchematicApi
   * @version 0.0.83
   */

  /**
   * Constructs a new SchematicApi. 
   * @alias module:api/SchematicApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create schematic
     * Creates new schematic
     * @param {module:model/Schematic} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Schematic} and HTTP response
     */
    this.createSchematicWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createSchematic");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Schematic;

      return this.apiClient.callApi(
        '/schematics', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create schematic
     * Creates new schematic
     * @param {module:model/Schematic} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Schematic}
     */
    this.createSchematic = function(body) {
      return this.createSchematicWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find schematic
     * Returns single schematic
     * @param {Number} schematicId schematic id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Schematic} and HTTP response
     */
    this.findSchematicWithHttpInfo = function(schematicId) {
      var postBody = null;

      // verify the required parameter 'schematicId' is set
      if (schematicId === undefined || schematicId === null) {
        throw new Error("Missing the required parameter 'schematicId' when calling findSchematic");
      }


      var pathParams = {
        'schematicId': schematicId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Schematic;

      return this.apiClient.callApi(
        '/schematics/{schematicId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find schematic
     * Returns single schematic
     * @param {Number} schematicId schematic id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Schematic}
     */
    this.findSchematic = function(schematicId) {
      return this.findSchematicWithHttpInfo(schematicId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find schematic data
     * Returns single schematic data
     * @param {Number} schematicId schematic id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link 'String'} and HTTP response
     */
    this.findSchematicDataWithHttpInfo = function(schematicId) {
      var postBody = null;

      // verify the required parameter 'schematicId' is set
      if (schematicId === undefined || schematicId === null) {
        throw new Error("Missing the required parameter 'schematicId' when calling findSchematicData");
      }


      var pathParams = {
        'schematicId': schematicId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = 'String';

      return this.apiClient.callApi(
        '/schematics/{schematicId}/data', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find schematic data
     * Returns single schematic data
     * @param {Number} schematicId schematic id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link 'String'}
     */
    this.findSchematicData = function(schematicId) {
      return this.findSchematicDataWithHttpInfo(schematicId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List schematics
     * list schematics
     * @param {Object} opts Optional parameters
     * @param {Number} opts.rowProductId Filter schematics by row product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/Schematic>} and HTTP response
     */
    this.listSchematicsWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'rowProductId': opts['rowProductId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [Schematic];

      return this.apiClient.callApi(
        '/schematics', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List schematics
     * list schematics
     * @param {Object} opts Optional parameters
     * @param {Number} opts.rowProductId Filter schematics by row product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/Schematic>}
     */
    this.listSchematics = function(opts) {
      return this.listSchematicsWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update schematic
     * Updates a schematic
     * @param {Number} schematicId schematic id
     * @param {module:model/Schematic} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/Schematic} and HTTP response
     */
    this.updateSchematicWithHttpInfo = function(schematicId, body) {
      var postBody = body;

      // verify the required parameter 'schematicId' is set
      if (schematicId === undefined || schematicId === null) {
        throw new Error("Missing the required parameter 'schematicId' when calling updateSchematic");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSchematic");
      }


      var pathParams = {
        'schematicId': schematicId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = Schematic;

      return this.apiClient.callApi(
        '/schematics/{schematicId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update schematic
     * Updates a schematic
     * @param {Number} schematicId schematic id
     * @param {module:model/Schematic} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/Schematic}
     */
    this.updateSchematic = function(schematicId, body) {
      return this.updateSchematicWithHttpInfo(schematicId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update schematic data
     * Updates a schematic data
     * @param {Number} schematicId schematic id
     * @param {String} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    this.updateSchematicDataWithHttpInfo = function(schematicId, body) {
      var postBody = null;

      // verify the required parameter 'schematicId' is set
      if (schematicId === undefined || schematicId === null) {
        throw new Error("Missing the required parameter 'schematicId' when calling updateSchematicData");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSchematicData");
      }


      var pathParams = {
        'schematicId': schematicId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'body': body
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = null;

      return this.apiClient.callApi(
        '/schematics/{schematicId}/data', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update schematic data
     * Updates a schematic data
     * @param {Number} schematicId schematic id
     * @param {String} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    this.updateSchematicData = function(schematicId, body) {
      return this.updateSchematicDataWithHttpInfo(schematicId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
