/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/StorageProduct'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/StorageProduct'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.StorageProductApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.StorageProduct);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, StorageProduct) {
  'use strict';

  /**
   * StorageProduct service.
   * @module api/StorageProductApi
   * @version 0.0.83
   */

  /**
   * Constructs a new StorageProductApi. 
   * @alias module:api/StorageProductApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create storage product
     * Create storage product
     * @param {module:model/StorageProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/StorageProduct} and HTTP response
     */
    this.createStorageProductWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createStorageProduct");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = StorageProduct;

      return this.apiClient.callApi(
        '/storageProducts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create storage product
     * Create storage product
     * @param {module:model/StorageProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/StorageProduct}
     */
    this.createStorageProduct = function(body) {
      return this.createStorageProductWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find a storage product
     * Returns single storage product
     * @param {Number} storageProductId storage product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/StorageProduct} and HTTP response
     */
    this.findStorageProductWithHttpInfo = function(storageProductId) {
      var postBody = null;

      // verify the required parameter 'storageProductId' is set
      if (storageProductId === undefined || storageProductId === null) {
        throw new Error("Missing the required parameter 'storageProductId' when calling findStorageProduct");
      }


      var pathParams = {
        'storageProductId': storageProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = StorageProduct;

      return this.apiClient.callApi(
        '/storageProducts/{storageProductId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find a storage product
     * Returns single storage product
     * @param {Number} storageProductId storage product id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/StorageProduct}
     */
    this.findStorageProduct = function(storageProductId) {
      return this.findStorageProductWithHttpInfo(storageProductId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List list products
     * list list products
     * @param {Object} opts Optional parameters
     * @param {Number} opts.listProductId Filter results by listProductId
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/StorageProduct>} and HTTP response
     */
    this.listStorageProductsWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'listProductId': opts['listProductId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [StorageProduct];

      return this.apiClient.callApi(
        '/storageProducts', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List list products
     * list list products
     * @param {Object} opts Optional parameters
     * @param {Number} opts.listProductId Filter results by listProductId
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/StorageProduct>}
     */
    this.listStorageProducts = function(opts) {
      return this.listStorageProductsWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update storage product
     * Updates a storage product
     * @param {Number} storageProductId storage product id
     * @param {module:model/StorageProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/StorageProduct} and HTTP response
     */
    this.updateStorageProductWithHttpInfo = function(storageProductId, body) {
      var postBody = body;

      // verify the required parameter 'storageProductId' is set
      if (storageProductId === undefined || storageProductId === null) {
        throw new Error("Missing the required parameter 'storageProductId' when calling updateStorageProduct");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateStorageProduct");
      }


      var pathParams = {
        'storageProductId': storageProductId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = StorageProduct;

      return this.apiClient.callApi(
        '/storageProducts/{storageProductId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update storage product
     * Updates a storage product
     * @param {Number} storageProductId storage product id
     * @param {module:model/StorageProduct} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/StorageProduct}
     */
    this.updateStorageProduct = function(storageProductId, body) {
      return this.updateStorageProductWithHttpInfo(storageProductId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
