/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/SupplierOrganization'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/SupplierOrganization'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SupplierOrganizationApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.SupplierOrganization);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, SupplierOrganization) {
  'use strict';

  /**
   * SupplierOrganization service.
   * @module api/SupplierOrganizationApi
   * @version 0.0.76
   */

  /**
   * Constructs a new SupplierOrganizationApi. 
   * @alias module:api/SupplierOrganizationApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create supplier organization
     * Creates new supplier organization
     * @param {module:model/SupplierOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SupplierOrganization} and HTTP response
     */
    this.createSupplierOrganizationWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createSupplierOrganization");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SupplierOrganization;

      return this.apiClient.callApi(
        '/supplierOrganizations', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create supplier organization
     * Creates new supplier organization
     * @param {module:model/SupplierOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SupplierOrganization}
     */
    this.createSupplierOrganization = function(body) {
      return this.createSupplierOrganizationWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find supplier organization
     * Returns single supplier organization
     * @param {Number} supplierOrganizationId supplier organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SupplierOrganization} and HTTP response
     */
    this.findSupplierOrganizationWithHttpInfo = function(supplierOrganizationId) {
      var postBody = null;

      // verify the required parameter 'supplierOrganizationId' is set
      if (supplierOrganizationId === undefined || supplierOrganizationId === null) {
        throw new Error("Missing the required parameter 'supplierOrganizationId' when calling findSupplierOrganization");
      }


      var pathParams = {
        'supplierOrganizationId': supplierOrganizationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SupplierOrganization;

      return this.apiClient.callApi(
        '/supplierOrganizations/{supplierOrganizationId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find supplier organization
     * Returns single supplier organization
     * @param {Number} supplierOrganizationId supplier organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SupplierOrganization}
     */
    this.findSupplierOrganization = function(supplierOrganizationId) {
      return this.findSupplierOrganizationWithHttpInfo(supplierOrganizationId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List supplierOrganizations
     * list supplier organizations
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/SupplierOrganization>} and HTTP response
     */
    this.listSupplierOrganizationsWithHttpInfo = function() {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [SupplierOrganization];

      return this.apiClient.callApi(
        '/supplierOrganizations', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List supplierOrganizations
     * list supplier organizations
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/SupplierOrganization>}
     */
    this.listSupplierOrganizations = function() {
      return this.listSupplierOrganizationsWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update supplier organization
     * Updates a supplier organization
     * @param {Number} supplierOrganizationId supplier organization id
     * @param {module:model/SupplierOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SupplierOrganization} and HTTP response
     */
    this.updateSupplierOrganizationWithHttpInfo = function(supplierOrganizationId, body) {
      var postBody = body;

      // verify the required parameter 'supplierOrganizationId' is set
      if (supplierOrganizationId === undefined || supplierOrganizationId === null) {
        throw new Error("Missing the required parameter 'supplierOrganizationId' when calling updateSupplierOrganization");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSupplierOrganization");
      }


      var pathParams = {
        'supplierOrganizationId': supplierOrganizationId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SupplierOrganization;

      return this.apiClient.callApi(
        '/supplierOrganizations/{supplierOrganizationId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update supplier organization
     * Updates a supplier organization
     * @param {Number} supplierOrganizationId supplier organization id
     * @param {module:model/SupplierOrganization} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SupplierOrganization}
     */
    this.updateSupplierOrganization = function(supplierOrganizationId, body) {
      return this.updateSupplierOrganizationWithHttpInfo(supplierOrganizationId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
