/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BadRequest', 'model/Forbidden', 'model/InternalServerError', 'model/SupplierRepresentative'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BadRequest'), require('../model/Forbidden'), require('../model/InternalServerError'), require('../model/SupplierRepresentative'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SupplierRepresentativeApi = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.BadRequest, root.KykyapiClient.Forbidden, root.KykyapiClient.InternalServerError, root.KykyapiClient.SupplierRepresentative);
  }
}(this, function(ApiClient, BadRequest, Forbidden, InternalServerError, SupplierRepresentative) {
  'use strict';

  /**
   * SupplierRepresentative service.
   * @module api/SupplierRepresentativeApi
   * @version 0.0.76
   */

  /**
   * Constructs a new SupplierRepresentativeApi. 
   * @alias module:api/SupplierRepresentativeApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;



    /**
     * Create supplier representative
     * Creates new supplier representative
     * @param {module:model/SupplierRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SupplierRepresentative} and HTTP response
     */
    this.createSupplierRepresentativeWithHttpInfo = function(body) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling createSupplierRepresentative");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SupplierRepresentative;

      return this.apiClient.callApi(
        '/supplierRepresentatives', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Create supplier representative
     * Creates new supplier representative
     * @param {module:model/SupplierRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SupplierRepresentative}
     */
    this.createSupplierRepresentative = function(body) {
      return this.createSupplierRepresentativeWithHttpInfo(body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Find supplier representative
     * Returns single supplier representative
     * @param {Number} supplierRepresentativeId supplier representative id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SupplierRepresentative} and HTTP response
     */
    this.findSupplierRepresentativeWithHttpInfo = function(supplierRepresentativeId) {
      var postBody = null;

      // verify the required parameter 'supplierRepresentativeId' is set
      if (supplierRepresentativeId === undefined || supplierRepresentativeId === null) {
        throw new Error("Missing the required parameter 'supplierRepresentativeId' when calling findSupplierRepresentative");
      }


      var pathParams = {
        'supplierRepresentativeId': supplierRepresentativeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SupplierRepresentative;

      return this.apiClient.callApi(
        '/supplierRepresentatives/{supplierRepresentativeId}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Find supplier representative
     * Returns single supplier representative
     * @param {Number} supplierRepresentativeId supplier representative id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SupplierRepresentative}
     */
    this.findSupplierRepresentative = function(supplierRepresentativeId) {
      return this.findSupplierRepresentativeWithHttpInfo(supplierRepresentativeId)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * List supplier representatives
     * list supplier representatives
     * @param {Object} opts Optional parameters
     * @param {Number} opts.supplierOrganizationId filter by supplier organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link Array.<module:model/SupplierRepresentative>} and HTTP response
     */
    this.listSupplierRepresentativesWithHttpInfo = function(opts) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'supplierOrganizationId': opts['supplierOrganizationId'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = [SupplierRepresentative];

      return this.apiClient.callApi(
        '/supplierRepresentatives', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * List supplier representatives
     * list supplier representatives
     * @param {Object} opts Optional parameters
     * @param {Number} opts.supplierOrganizationId filter by supplier organization id
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link Array.<module:model/SupplierRepresentative>}
     */
    this.listSupplierRepresentatives = function(opts) {
      return this.listSupplierRepresentativesWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Update supplier representative
     * Updates a supplier representative
     * @param {Number} supplierRepresentativeId supplier representative id
     * @param {module:model/SupplierRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SupplierRepresentative} and HTTP response
     */
    this.updateSupplierRepresentativeWithHttpInfo = function(supplierRepresentativeId, body) {
      var postBody = body;

      // verify the required parameter 'supplierRepresentativeId' is set
      if (supplierRepresentativeId === undefined || supplierRepresentativeId === null) {
        throw new Error("Missing the required parameter 'supplierRepresentativeId' when calling updateSupplierRepresentative");
      }

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling updateSupplierRepresentative");
      }


      var pathParams = {
        'supplierRepresentativeId': supplierRepresentativeId
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['bearer'];
      var contentTypes = ['application/json;charset=utf-8'];
      var accepts = ['application/json;charset=utf-8'];
      var returnType = SupplierRepresentative;

      return this.apiClient.callApi(
        '/supplierRepresentatives/{supplierRepresentativeId}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType
      );
    }

    /**
     * Update supplier representative
     * Updates a supplier representative
     * @param {Number} supplierRepresentativeId supplier representative id
     * @param {module:model/SupplierRepresentative} body Payload
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SupplierRepresentative}
     */
    this.updateSupplierRepresentative = function(supplierRepresentativeId, body) {
      return this.updateSupplierRepresentativeWithHttpInfo(supplierRepresentativeId, body)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }
  };

  return exports;
}));
