/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Address'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.CustomerOrganization = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.Address);
  }
}(this, function(ApiClient, Address) {
  'use strict';




  /**
   * The CustomerOrganization model module.
   * @module model/CustomerOrganization
   * @version 0.0.83
   */

  /**
   * Constructs a new <code>CustomerOrganization</code>.
   * @alias module:model/CustomerOrganization
   * @class
   * @param businessName {String} Customer's business name
   */
  var exports = function(businessName) {
    var _this = this;




    _this['businessName'] = businessName;







  };

  /**
   * Constructs a <code>CustomerOrganization</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CustomerOrganization} obj Optional instance to populate.
   * @return {module:model/CustomerOrganization} The populated <code>CustomerOrganization</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Number');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('customerNumber')) {
        obj['customerNumber'] = ApiClient.convertToType(data['customerNumber'], 'String');
      }
      if (data.hasOwnProperty('businessName')) {
        obj['businessName'] = ApiClient.convertToType(data['businessName'], 'String');
      }
      if (data.hasOwnProperty('businessCode')) {
        obj['businessCode'] = ApiClient.convertToType(data['businessCode'], 'String');
      }
      if (data.hasOwnProperty('webpage')) {
        obj['webpage'] = ApiClient.convertToType(data['webpage'], 'String');
      }
      if (data.hasOwnProperty('catalogueId')) {
        obj['catalogueId'] = ApiClient.convertToType(data['catalogueId'], 'Number');
      }
      if (data.hasOwnProperty('billingAddress')) {
        obj['billingAddress'] = Address.constructFromObject(data['billingAddress']);
      }
      if (data.hasOwnProperty('billingContactName')) {
        obj['billingContactName'] = ApiClient.convertToType(data['billingContactName'], 'String');
      }
      if (data.hasOwnProperty('billingContactEmail')) {
        obj['billingContactEmail'] = ApiClient.convertToType(data['billingContactEmail'], 'String');
      }
      if (data.hasOwnProperty('additionalInformation')) {
        obj['additionalInformation'] = ApiClient.convertToType(data['additionalInformation'], 'String');
      }
    }
    return obj;
  }

  /**
   * Entity identifier
   * @member {Number} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Customer organization type
   * @member {module:model/CustomerOrganization.TypeEnum} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Customer's number
   * @member {String} customerNumber
   */
  exports.prototype['customerNumber'] = undefined;
  /**
   * Customer's business name
   * @member {String} businessName
   */
  exports.prototype['businessName'] = undefined;
  /**
   * Customer's business code
   * @member {String} businessCode
   */
  exports.prototype['businessCode'] = undefined;
  /**
   * Customer's webpage
   * @member {String} webpage
   */
  exports.prototype['webpage'] = undefined;
  /**
   * Customer's catalogue id
   * @member {Number} catalogueId
   */
  exports.prototype['catalogueId'] = undefined;
  /**
   * @member {module:model/Address} billingAddress
   */
  exports.prototype['billingAddress'] = undefined;
  /**
   * Customer's billing contact's name
   * @member {String} billingContactName
   */
  exports.prototype['billingContactName'] = undefined;
  /**
   * Customer's billing contact's email
   * @member {String} billingContactEmail
   */
  exports.prototype['billingContactEmail'] = undefined;
  /**
   * Additional information about the customer.
   * @member {String} additionalInformation
   */
  exports.prototype['additionalInformation'] = undefined;


  /**
   * Allowed values for the <code>type</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TypeEnum = {
    /**
     * value: "CUSTOMER"
     * @const
     */
    "CUSTOMER": "CUSTOMER",
    /**
     * value: "SUPPLIER"
     * @const
     */
    "SUPPLIER": "SUPPLIER"  };


  return exports;
}));


