/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.ListProduct = factory(root.KykyapiClient.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ListProduct model module.
   * @module model/ListProduct
   * @version 0.0.83
   */

  /**
   * Constructs a new <code>ListProduct</code>.
   * List product
   * @alias module:model/ListProduct
   * @class
   * @param name {String} Product name
   * @param category {module:model/ListProduct.CategoryEnum} Product category
   * @param unit {module:model/ListProduct.UnitEnum} Product unit
   * @param unitPrice {String} Price for single unit
   */
  var exports = function(name, category, unit, unitPrice) {
    var _this = this;


    _this['name'] = name;
    _this['category'] = category;
    _this['unit'] = unit;

    _this['unitPrice'] = unitPrice;

  };

  /**
   * Constructs a <code>ListProduct</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ListProduct} obj Optional instance to populate.
   * @return {module:model/ListProduct} The populated <code>ListProduct</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Number');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('category')) {
        obj['category'] = ApiClient.convertToType(data['category'], 'String');
      }
      if (data.hasOwnProperty('unit')) {
        obj['unit'] = ApiClient.convertToType(data['unit'], 'String');
      }
      if (data.hasOwnProperty('storageProduct')) {
        obj['storageProduct'] = ApiClient.convertToType(data['storageProduct'], 'Boolean');
      }
      if (data.hasOwnProperty('unitPrice')) {
        obj['unitPrice'] = ApiClient.convertToType(data['unitPrice'], 'String');
      }
      if (data.hasOwnProperty('attachmentIds')) {
        obj['attachmentIds'] = ApiClient.convertToType(data['attachmentIds'], ['Number']);
      }
    }
    return obj;
  }

  /**
   * Product identifier
   * @member {Number} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Product name
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Product category
   * @member {module:model/ListProduct.CategoryEnum} category
   */
  exports.prototype['category'] = undefined;
  /**
   * Product unit
   * @member {module:model/ListProduct.UnitEnum} unit
   */
  exports.prototype['unit'] = undefined;
  /**
   * @member {Boolean} storageProduct
   */
  exports.prototype['storageProduct'] = undefined;
  /**
   * Price for single unit
   * @member {String} unitPrice
   */
  exports.prototype['unitPrice'] = undefined;
  /**
   * @member {Array.<Number>} attachmentIds
   */
  exports.prototype['attachmentIds'] = undefined;


  /**
   * Allowed values for the <code>category</code> property.
   * @enum {String}
   * @readonly
   */
  exports.CategoryEnum = {
    /**
     * value: "GLASS"
     * @const
     */
    "GLASS": "GLASS",
    /**
     * value: "GRINDING"
     * @const
     */
    "GRINDING": "GRINDING",
    /**
     * value: "HINGE"
     * @const
     */
    "HINGE": "HINGE",
    /**
     * value: "HANDLE"
     * @const
     */
    "HANDLE": "HANDLE",
    /**
     * value: "ACCESSORY"
     * @const
     */
    "ACCESSORY": "ACCESSORY",
    /**
     * value: "SCHEMATIC"
     * @const
     */
    "SCHEMATIC": "SCHEMATIC"  };

  /**
   * Allowed values for the <code>unit</code> property.
   * @enum {String}
   * @readonly
   */
  exports.UnitEnum = {
    /**
     * value: "UNIT"
     * @const
     */
    "UNIT": "UNIT",
    /**
     * value: "METER"
     * @const
     */
    "METER": "METER",
    /**
     * value: "SQUARE_METER"
     * @const
     */
    "SQUARE_METER": "SQUARE_METER"  };


  return exports;
}));


