/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address', 'model/PurchaseOrderInvoice'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Address'), require('./PurchaseOrderInvoice'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.PurchaseOrder = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.Address, root.KykyapiClient.PurchaseOrderInvoice);
  }
}(this, function(ApiClient, Address, PurchaseOrderInvoice) {
  'use strict';




  /**
   * The PurchaseOrder model module.
   * @module model/PurchaseOrder
   * @version 0.0.83
   */

  /**
   * Constructs a new <code>PurchaseOrder</code>.
   * Purchase order
   * @alias module:model/PurchaseOrder
   * @class
   * @param saleId {Number} Entity identifier.
   * @param state {module:model/PurchaseOrder.StateEnum} 
   */
  var exports = function(saleId, state) {
    var _this = this;


    _this['saleId'] = saleId;

    _this['state'] = state;









  };

  /**
   * Constructs a <code>PurchaseOrder</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PurchaseOrder} obj Optional instance to populate.
   * @return {module:model/PurchaseOrder} The populated <code>PurchaseOrder</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Number');
      }
      if (data.hasOwnProperty('saleId')) {
        obj['saleId'] = ApiClient.convertToType(data['saleId'], 'Number');
      }
      if (data.hasOwnProperty('customerOrganizationId')) {
        obj['customerOrganizationId'] = ApiClient.convertToType(data['customerOrganizationId'], 'Number');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('purchaseTime')) {
        obj['purchaseTime'] = ApiClient.convertToType(data['purchaseTime'], 'Date');
      }
      if (data.hasOwnProperty('arrivalTime')) {
        obj['arrivalTime'] = ApiClient.convertToType(data['arrivalTime'], 'Date');
      }
      if (data.hasOwnProperty('arrivalTimeEstimation')) {
        obj['arrivalTimeEstimation'] = ApiClient.convertToType(data['arrivalTimeEstimation'], 'Date');
      }
      if (data.hasOwnProperty('consigneeId')) {
        obj['consigneeId'] = ApiClient.convertToType(data['consigneeId'], 'String');
      }
      if (data.hasOwnProperty('invoices')) {
        obj['invoices'] = ApiClient.convertToType(data['invoices'], [PurchaseOrderInvoice]);
      }
      if (data.hasOwnProperty('billingAddress')) {
        obj['billingAddress'] = Address.constructFromObject(data['billingAddress']);
      }
      if (data.hasOwnProperty('deliveryAddress')) {
        obj['deliveryAddress'] = Address.constructFromObject(data['deliveryAddress']);
      }
      if (data.hasOwnProperty('additionalInformation')) {
        obj['additionalInformation'] = ApiClient.convertToType(data['additionalInformation'], 'String');
      }
      if (data.hasOwnProperty('internalNotes')) {
        obj['internalNotes'] = ApiClient.convertToType(data['internalNotes'], 'String');
      }
    }
    return obj;
  }

  /**
   * Entity identifier.
   * @member {Number} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Entity identifier.
   * @member {Number} saleId
   */
  exports.prototype['saleId'] = undefined;
  /**
   * Id of the seller
   * @member {Number} customerOrganizationId
   */
  exports.prototype['customerOrganizationId'] = undefined;
  /**
   * @member {module:model/PurchaseOrder.StateEnum} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Order purchase time
   * @member {Date} purchaseTime
   */
  exports.prototype['purchaseTime'] = undefined;
  /**
   * Order arrival time
   * @member {Date} arrivalTime
   */
  exports.prototype['arrivalTime'] = undefined;
  /**
   * Estimated arrival time
   * @member {Date} arrivalTimeEstimation
   */
  exports.prototype['arrivalTimeEstimation'] = undefined;
  /**
   * Order consignee id
   * @member {String} consigneeId
   */
  exports.prototype['consigneeId'] = undefined;
  /**
   * @member {Array.<module:model/PurchaseOrderInvoice>} invoices
   */
  exports.prototype['invoices'] = undefined;
  /**
   * @member {module:model/Address} billingAddress
   */
  exports.prototype['billingAddress'] = undefined;
  /**
   * @member {module:model/Address} deliveryAddress
   */
  exports.prototype['deliveryAddress'] = undefined;
  /**
   * Additional information about the purchase
   * @member {String} additionalInformation
   */
  exports.prototype['additionalInformation'] = undefined;
  /**
   * Internal notes about the purchase
   * @member {String} internalNotes
   */
  exports.prototype['internalNotes'] = undefined;


  /**
   * Allowed values for the <code>state</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StateEnum = {
    /**
     * value: "DRAFT"
     * @const
     */
    "DRAFT": "DRAFT",
    /**
     * value: "OPEN"
     * @const
     */
    "OPEN": "OPEN",
    /**
     * value: "ARRIVED"
     * @const
     */
    "ARRIVED": "ARRIVED",
    /**
     * value: "BILLED"
     * @const
     */
    "BILLED": "BILLED"  };


  return exports;
}));


