/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Address'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.Sale = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.Address);
  }
}(this, function(ApiClient, Address) {
  'use strict';




  /**
   * The Sale model module.
   * @module model/Sale
   * @version 0.0.83
   */

  /**
   * Constructs a new <code>Sale</code>.
   * Sale
   * @alias module:model/Sale
   * @class
   * @param customerOrganizationId {Number} Entity identifier.
   * @param state {module:model/Sale.StateEnum} Sale state
   */
  var exports = function(customerOrganizationId, state) {
    var _this = this;



    _this['customerOrganizationId'] = customerOrganizationId;

    _this['state'] = state;
  };

  /**
   * Constructs a <code>Sale</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Sale} obj Optional instance to populate.
   * @return {module:model/Sale} The populated <code>Sale</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Number');
      }
      if (data.hasOwnProperty('deliveryAddress')) {
        obj['deliveryAddress'] = Address.constructFromObject(data['deliveryAddress']);
      }
      if (data.hasOwnProperty('customerOrganizationId')) {
        obj['customerOrganizationId'] = ApiClient.convertToType(data['customerOrganizationId'], 'Number');
      }
      if (data.hasOwnProperty('marker')) {
        obj['marker'] = ApiClient.convertToType(data['marker'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
    }
    return obj;
  }

  /**
   * Entity identifier.
   * @member {Number} id
   */
  exports.prototype['id'] = undefined;
  /**
   * @member {module:model/Address} deliveryAddress
   */
  exports.prototype['deliveryAddress'] = undefined;
  /**
   * Entity identifier.
   * @member {Number} customerOrganizationId
   */
  exports.prototype['customerOrganizationId'] = undefined;
  /**
   * sale marker
   * @member {String} marker
   */
  exports.prototype['marker'] = undefined;
  /**
   * Sale state
   * @member {module:model/Sale.StateEnum} state
   */
  exports.prototype['state'] = undefined;


  /**
   * Allowed values for the <code>state</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StateEnum = {
    /**
     * value: "OFFER"
     * @const
     */
    "OFFER": "OFFER",
    /**
     * value: "ORDER"
     * @const
     */
    "ORDER": "ORDER",
    /**
     * value: "BILLING"
     * @const
     */
    "BILLING": "BILLING",
    /**
     * value: "DONE"
     * @const
     */
    "DONE": "DONE",
    /**
     * value: "ARCHIVED"
     * @const
     */
    "ARCHIVED": "ARCHIVED"  };


  return exports;
}));


