/**
 * KYKY API
 * KYKY Lasi Oy - ERP API
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Address'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Address'));
  } else {
    // Browser globals (root is window)
    if (!root.KykyapiClient) {
      root.KykyapiClient = {};
    }
    root.KykyapiClient.SaleOrder = factory(root.KykyapiClient.ApiClient, root.KykyapiClient.Address);
  }
}(this, function(ApiClient, Address) {
  'use strict';




  /**
   * The SaleOrder model module.
   * @module model/SaleOrder
   * @version 0.0.83
   */

  /**
   * Constructs a new <code>SaleOrder</code>.
   * Sale order
   * @alias module:model/SaleOrder
   * @class
   * @param saleId {Number} Entity identifier.
   * @param customerRepresentativeId {Number} Id of the customer representative
   * @param delivery {module:model/SaleOrder.DeliveryEnum} 
   * @param termsOfPayment {module:model/SaleOrder.TermsOfPaymentEnum} 
   * @param latePaymentInterest {Number} Interest about late payment
   */
  var exports = function(saleId, customerRepresentativeId, delivery, termsOfPayment, latePaymentInterest) {
    var _this = this;


    _this['saleId'] = saleId;
    _this['customerRepresentativeId'] = customerRepresentativeId;
    _this['delivery'] = delivery;




    _this['termsOfPayment'] = termsOfPayment;
    _this['latePaymentInterest'] = latePaymentInterest;



  };

  /**
   * Constructs a <code>SaleOrder</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SaleOrder} obj Optional instance to populate.
   * @return {module:model/SaleOrder} The populated <code>SaleOrder</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Number');
      }
      if (data.hasOwnProperty('saleId')) {
        obj['saleId'] = ApiClient.convertToType(data['saleId'], 'Number');
      }
      if (data.hasOwnProperty('customerRepresentativeId')) {
        obj['customerRepresentativeId'] = ApiClient.convertToType(data['customerRepresentativeId'], 'Number');
      }
      if (data.hasOwnProperty('delivery')) {
        obj['delivery'] = ApiClient.convertToType(data['delivery'], 'String');
      }
      if (data.hasOwnProperty('additionalInformation')) {
        obj['additionalInformation'] = ApiClient.convertToType(data['additionalInformation'], 'String');
      }
      if (data.hasOwnProperty('marker')) {
        obj['marker'] = ApiClient.convertToType(data['marker'], 'String');
      }
      if (data.hasOwnProperty('internalNotes')) {
        obj['internalNotes'] = ApiClient.convertToType(data['internalNotes'], 'String');
      }
      if (data.hasOwnProperty('responsibleUserId')) {
        obj['responsibleUserId'] = ApiClient.convertToType(data['responsibleUserId'], 'String');
      }
      if (data.hasOwnProperty('termsOfPayment')) {
        obj['termsOfPayment'] = ApiClient.convertToType(data['termsOfPayment'], 'String');
      }
      if (data.hasOwnProperty('latePaymentInterest')) {
        obj['latePaymentInterest'] = ApiClient.convertToType(data['latePaymentInterest'], 'Number');
      }
      if (data.hasOwnProperty('deliveryTime')) {
        obj['deliveryTime'] = ApiClient.convertToType(data['deliveryTime'], 'Date');
      }
      if (data.hasOwnProperty('billingAddress')) {
        obj['billingAddress'] = Address.constructFromObject(data['billingAddress']);
      }
      if (data.hasOwnProperty('referenceNumber')) {
        obj['referenceNumber'] = ApiClient.convertToType(data['referenceNumber'], 'String');
      }
    }
    return obj;
  }

  /**
   * Entity identifier.
   * @member {Number} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Entity identifier.
   * @member {Number} saleId
   */
  exports.prototype['saleId'] = undefined;
  /**
   * Id of the customer representative
   * @member {Number} customerRepresentativeId
   */
  exports.prototype['customerRepresentativeId'] = undefined;
  /**
   * @member {module:model/SaleOrder.DeliveryEnum} delivery
   */
  exports.prototype['delivery'] = undefined;
  /**
   * Additional information about the sale offer
   * @member {String} additionalInformation
   */
  exports.prototype['additionalInformation'] = undefined;
  /**
   * sale offers marker
   * @member {String} marker
   */
  exports.prototype['marker'] = undefined;
  /**
   * Internal notes about the sale offer
   * @member {String} internalNotes
   */
  exports.prototype['internalNotes'] = undefined;
  /**
   * Id of responsible user
   * @member {String} responsibleUserId
   */
  exports.prototype['responsibleUserId'] = undefined;
  /**
   * @member {module:model/SaleOrder.TermsOfPaymentEnum} termsOfPayment
   */
  exports.prototype['termsOfPayment'] = undefined;
  /**
   * Interest about late payment
   * @member {Number} latePaymentInterest
   */
  exports.prototype['latePaymentInterest'] = undefined;
  /**
   * @member {Date} deliveryTime
   */
  exports.prototype['deliveryTime'] = undefined;
  /**
   * @member {module:model/Address} billingAddress
   */
  exports.prototype['billingAddress'] = undefined;
  /**
   * Reference number
   * @member {String} referenceNumber
   */
  exports.prototype['referenceNumber'] = undefined;


  /**
   * Allowed values for the <code>delivery</code> property.
   * @enum {String}
   * @readonly
   */
  exports.DeliveryEnum = {
    /**
     * value: "PICKUP"
     * @const
     */
    "PICKUP": "PICKUP",
    /**
     * value: "DELIVERY"
     * @const
     */
    "DELIVERY": "DELIVERY",
    /**
     * value: "INSTALLATION"
     * @const
     */
    "INSTALLATION": "INSTALLATION"  };

  /**
   * Allowed values for the <code>termsOfPayment</code> property.
   * @enum {String}
   * @readonly
   */
  exports.TermsOfPaymentEnum = {
    /**
     * value: "CASH"
     * @const
     */
    "CASH": "CASH",
    /**
     * value: "BILL7"
     * @const
     */
    "BILL7": "BILL7",
    /**
     * value: "BILL14"
     * @const
     */
    "BILL14": "BILL14",
    /**
     * value: "BILL21"
     * @const
     */
    "BILL21": "BILL21",
    /**
     * value: "BILL31"
     * @const
     */
    "BILL31": "BILL31"  };


  return exports;
}));


